#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 556
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 335
#define ALIAS_COUNT 0
#define TOKEN_COUNT 175
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 49
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 119

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_module = 2,
  anon_sym_version = 3,
  anon_sym_is = 4,
  anon_sym_end = 5,
  anon_sym_import = 6,
  anon_sym_LBRACK = 7,
  anon_sym_RBRACK = 8,
  anon_sym_from = 9,
  anon_sym_COLON_COLON = 10,
  anon_sym_COLON_COLON2 = 11,
  anon_sym_as = 12,
  anon_sym_COLON = 13,
  anon_sym_AT = 14,
  anon_sym_EQ = 15,
  anon_sym_assert = 16,
  sym_controlled_language_tag = 17,
  anon_sym_LPAREN = 18,
  anon_sym_RPAREN = 19,
  anon_sym_COMMA = 20,
  sym_reserved_self = 21,
  anon_sym_with = 22,
  anon_sym_def = 23,
  anon_sym_LBRACE = 24,
  anon_sym_RBRACE = 25,
  anon_sym_Thing = 26,
  anon_sym_Nothing = 27,
  anon_sym_real = 28,
  anon_sym_rational = 29,
  anon_sym_anyURI = 30,
  anon_sym_iri = 31,
  anon_sym_base64Binary = 32,
  anon_sym_boolean = 33,
  anon_sym_date = 34,
  anon_sym_dateTime = 35,
  anon_sym_decimal = 36,
  anon_sym_double = 37,
  anon_sym_duration = 38,
  anon_sym_float = 39,
  anon_sym_gDay = 40,
  anon_sym_gMonth = 41,
  anon_sym_gMonthDay = 42,
  anon_sym_gYearMonth = 43,
  anon_sym_gYear = 44,
  anon_sym_hexBinary = 45,
  anon_sym_binary = 46,
  anon_sym_string = 47,
  anon_sym_time = 48,
  anon_sym_dateTimeStamp = 49,
  anon_sym_dayTimeDuration = 50,
  anon_sym_yearMonthDuration = 51,
  anon_sym_integer = 52,
  anon_sym_long = 53,
  anon_sym_int = 54,
  anon_sym_short = 55,
  anon_sym_byte = 56,
  anon_sym_nonNegativeInteger = 57,
  anon_sym_positiveInteger = 58,
  anon_sym_unsignedLong = 59,
  anon_sym_unsignedInt = 60,
  anon_sym_unsigned = 61,
  anon_sym_unsignedShort = 62,
  anon_sym_unsignedByte = 63,
  anon_sym_nonPositiveInteger = 64,
  anon_sym_negativeInteger = 65,
  anon_sym_normalizedString = 66,
  anon_sym_token = 67,
  anon_sym_language = 68,
  sym_quoted_string = 69,
  sym_language_tag = 70,
  anon_sym_LT = 71,
  aux_sym_iri_token1 = 72,
  anon_sym_GT = 73,
  anon_sym_POUND_LBRACK = 74,
  sym_hex_byte = 75,
  sym_double = 76,
  sym_decimal = 77,
  sym_integer = 78,
  sym_rational = 79,
  sym_unsigned = 80,
  anon_sym_true = 81,
  anon_sym_u22a4 = 82,
  anon_sym_false = 83,
  anon_sym_u22a5 = 84,
  anon_sym_datatype = 85,
  sym_opaque = 86,
  anon_sym_length = 87,
  anon_sym_maxLength = 88,
  anon_sym_minLength = 89,
  anon_sym_fractionDigits = 90,
  anon_sym_totalDigits = 91,
  anon_sym_maxExclusive = 92,
  anon_sym_maxInclusive = 93,
  anon_sym_minExclusive = 94,
  anon_sym_minInclusive = 95,
  anon_sym_explicitTimezone = 96,
  anon_sym_required = 97,
  anon_sym_prohibited = 98,
  anon_sym_optional = 99,
  anon_sym_pattern = 100,
  sym_kw_is_fixed = 101,
  anon_sym_dimension = 102,
  anon_sym_source = 103,
  anon_sym_parent = 104,
  anon_sym_entity = 105,
  anon_sym_enum = 106,
  anon_sym_of = 107,
  anon_sym_event = 108,
  anon_sym_property = 109,
  anon_sym_structure = 110,
  anon_sym_union = 111,
  anon_sym_rdf = 112,
  anon_sym_a = 113,
  anon_sym_type = 114,
  anon_sym_class = 115,
  sym_wildcard = 116,
  anon_sym_identity = 117,
  anon_sym_ref = 118,
  sym_unknown_type = 119,
  anon_sym_ordered = 120,
  anon_sym_unordered = 121,
  anon_sym_unique = 122,
  anon_sym_nonunique = 123,
  anon_sym_DOT_DOT = 124,
  anon_sym_SLASH_EQ = 125,
  anon_sym_u2260 = 126,
  sym_op_less_than = 127,
  sym_op_greater_than = 128,
  anon_sym_LT_EQ = 129,
  anon_sym_u2264 = 130,
  anon_sym_GT_EQ = 131,
  anon_sym_u2265 = 132,
  anon_sym_not = 133,
  anon_sym_u00ac = 134,
  anon_sym_and = 135,
  anon_sym_u2227 = 136,
  anon_sym_or = 137,
  anon_sym_u2228 = 138,
  anon_sym_xor = 139,
  anon_sym_u22bb = 140,
  anon_sym_implies = 141,
  anon_sym_EQ_EQ_GT = 142,
  anon_sym_u21d2 = 143,
  anon_sym_iff = 144,
  anon_sym_LT_EQ_EQ_GT = 145,
  anon_sym_u21d4 = 146,
  anon_sym_forall = 147,
  anon_sym_u2200 = 148,
  anon_sym_exists = 149,
  anon_sym_u2203 = 150,
  anon_sym_u222a = 151,
  anon_sym_intersection = 152,
  anon_sym_u2229 = 153,
  anon_sym_subset = 154,
  anon_sym_u2282 = 155,
  anon_sym_subseteq = 156,
  anon_sym_u2286 = 157,
  anon_sym_complement = 158,
  anon_sym_u2216 = 159,
  anon_sym_in = 160,
  anon_sym_u2208 = 161,
  sym_set_op_builder = 162,
  anon_sym_u00b7 = 163,
  anon_sym_DOT = 164,
  anon_sym_COLON_EQ = 165,
  anon_sym_u2254 = 166,
  anon_sym_u2192 = 167,
  anon_sym_DASH_GT = 168,
  anon_sym_u2190 = 169,
  anon_sym_LT_DASH = 170,
  anon_sym_PLUS = 171,
  anon_sym_u2295 = 172,
  sym__value_empty_sequence = 173,
  sym_line_comment = 174,
  sym_module = 175,
  sym__module_locations = 176,
  sym_module_body = 177,
  sym_import_statement = 178,
  sym_from_clause = 179,
  sym_module_path_root_only = 180,
  sym_module_path_absolute = 181,
  sym_module_path_relative = 182,
  sym__import = 183,
  sym__rename_import = 184,
  sym_member_import = 185,
  sym_module_import = 186,
  sym_qualified_identifier = 187,
  sym_identifier_reference = 188,
  sym_annotation = 189,
  sym_annotation_property = 190,
  sym_constraint = 191,
  sym_informal_constraint = 192,
  sym_formal_constraint = 193,
  sym_constraint_sentence = 194,
  sym_simple_sentence = 195,
  sym_atomic_sentence = 196,
  sym__actual_arguments = 197,
  sym_equation = 198,
  sym_inequation = 199,
  sym_boolean_sentence = 200,
  sym_unary_boolean_sentence = 201,
  sym_binary_boolean_sentence = 202,
  sym__logical_connective = 203,
  sym_quantified_sentence = 204,
  sym_quantified_variable_binding = 205,
  sym_quantified_variable = 206,
  sym_variable = 207,
  sym_term = 208,
  sym_functional_term = 209,
  sym_function_composition = 210,
  sym_predicate_value = 211,
  sym_sequence_of_predicate_values = 212,
  sym_constraint_environment = 213,
  sym_function_def = 214,
  sym_function_signature = 215,
  sym_function_parameter = 216,
  sym__function_type = 217,
  sym_function_cardinality_expression = 218,
  sym_function_type_reference = 219,
  sym_function_body = 220,
  sym_sequence_builder = 221,
  sym_sequence_builder_body = 222,
  sym_value = 223,
  sym_sequence_of_values = 224,
  sym__sequence_value_constraints = 225,
  sym_value_constructor = 226,
  sym_mapping_value = 227,
  sym_builtin_simple_type = 228,
  sym__owl_builtin_types = 229,
  sym__builtin_primitive_datatypes = 230,
  sym__derived_date_datetypes = 231,
  sym__derived_numeric_datatypes = 232,
  sym__derived_string_datatypes = 233,
  sym_simple_value = 234,
  sym_string = 235,
  sym_iri = 236,
  sym_binary = 237,
  sym_boolean = 238,
  sym_boolean_truth = 239,
  sym_boolean_falsity = 240,
  sym_definition = 241,
  sym_data_type_def = 242,
  sym__datatype_base = 243,
  sym_datatype_def_restriction = 244,
  sym__restriction_facet = 245,
  sym_length_restriction_facet = 246,
  sym_digit_restriction_facet = 247,
  sym_value_restriction_facet = 248,
  sym_restriction_value = 249,
  sym_tz_restriction_facet = 250,
  sym_tz_restriction_value = 251,
  sym_pattern_restriction_facet = 252,
  sym_annotation_only_body = 253,
  sym_dimension_def = 254,
  sym_dimension_body = 255,
  sym_source_entity = 256,
  sym__identifier_or_sequence = 257,
  sym_dimension_parent = 258,
  sym_entity_def = 259,
  sym_entity_body = 260,
  sym_enum_def = 261,
  sym_enum_body = 262,
  sym_event_def = 263,
  sym_event_body = 264,
  sym_property_def = 265,
  sym_structure_def = 266,
  sym_structure_body = 267,
  sym_union_def = 268,
  sym_union_body = 269,
  sym_rdf_def = 270,
  sym_rdf_types = 271,
  sym_type_class_def = 272,
  sym_type_variable = 273,
  sym_type_variable_restriction = 274,
  sym_type_class_reference = 275,
  sym_type_class_arguments = 276,
  sym_type_class_body = 277,
  sym_method_def = 278,
  sym_entity_identity = 279,
  sym_member = 280,
  sym_member_def = 281,
  sym_property_ref = 282,
  sym__type_expression_to = 283,
  sym_type_reference = 284,
  sym_mapping_type = 285,
  sym_cardinality_expression = 286,
  sym__cardinality_inner = 287,
  sym_sequence_ordering = 288,
  sym_sequence_uniqueness = 289,
  sym_cardinality_range = 290,
  sym_value_variant = 291,
  sym_type_variant = 292,
  sym_op_inequality = 293,
  sym_op_less_than_or_equal = 294,
  sym_op_greater_than_or_equal = 295,
  sym_logical_op_negation = 296,
  sym_logical_op_conjunction = 297,
  sym_logical_op_disjunction = 298,
  sym_logical_op_exclusive_disjunction = 299,
  sym_logical_op_implication = 300,
  sym_logical_op_biconditional = 301,
  sym_logical_quantifier_universal = 302,
  sym_logical_quantifier_existential = 303,
  sym_set_op_membership = 304,
  sym__function_op_composition = 305,
  sym__function_op_by_definition = 306,
  sym__type_op_has_type = 307,
  sym__type_op_type_restriction = 308,
  sym_type_op_combiner = 309,
  aux_sym_module_body_repeat1 = 310,
  aux_sym_module_body_repeat2 = 311,
  aux_sym_module_body_repeat3 = 312,
  aux_sym_import_statement_repeat1 = 313,
  aux_sym_module_path_absolute_repeat1 = 314,
  aux_sym__actual_arguments_repeat1 = 315,
  aux_sym_function_composition_repeat1 = 316,
  aux_sym_sequence_of_predicate_values_repeat1 = 317,
  aux_sym_constraint_environment_repeat1 = 318,
  aux_sym_function_signature_repeat1 = 319,
  aux_sym_sequence_builder_repeat1 = 320,
  aux_sym_sequence_of_values_repeat1 = 321,
  aux_sym_binary_repeat1 = 322,
  aux_sym_datatype_def_restriction_repeat1 = 323,
  aux_sym_pattern_restriction_facet_repeat1 = 324,
  aux_sym_dimension_body_repeat1 = 325,
  aux_sym_dimension_body_repeat2 = 326,
  aux_sym__identifier_or_sequence_repeat1 = 327,
  aux_sym_enum_body_repeat1 = 328,
  aux_sym_union_body_repeat1 = 329,
  aux_sym_rdf_types_repeat1 = 330,
  aux_sym_type_class_def_repeat1 = 331,
  aux_sym_type_variable_restriction_repeat1 = 332,
  aux_sym_type_class_arguments_repeat1 = 333,
  aux_sym_type_class_body_repeat1 = 334,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_module] = "module",
  [anon_sym_version] = "version",
  [anon_sym_is] = "is",
  [anon_sym_end] = "end",
  [anon_sym_import] = "import",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_from] = "from",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_as] = "as",
  [anon_sym_COLON] = ":",
  [anon_sym_AT] = "@",
  [anon_sym_EQ] = "=",
  [anon_sym_assert] = "assert",
  [sym_controlled_language_tag] = "controlled_language_tag",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [sym_reserved_self] = "reserved_self",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_Thing] = "Thing",
  [anon_sym_Nothing] = "Nothing",
  [anon_sym_real] = "real",
  [anon_sym_rational] = "rational",
  [anon_sym_anyURI] = "anyURI",
  [anon_sym_iri] = "iri",
  [anon_sym_base64Binary] = "base64Binary",
  [anon_sym_boolean] = "boolean",
  [anon_sym_date] = "date",
  [anon_sym_dateTime] = "dateTime",
  [anon_sym_decimal] = "decimal",
  [anon_sym_double] = "double",
  [anon_sym_duration] = "duration",
  [anon_sym_float] = "float",
  [anon_sym_gDay] = "gDay",
  [anon_sym_gMonth] = "gMonth",
  [anon_sym_gMonthDay] = "gMonthDay",
  [anon_sym_gYearMonth] = "gYearMonth",
  [anon_sym_gYear] = "gYear",
  [anon_sym_hexBinary] = "hexBinary",
  [anon_sym_binary] = "binary",
  [anon_sym_string] = "string",
  [anon_sym_time] = "time",
  [anon_sym_dateTimeStamp] = "dateTimeStamp",
  [anon_sym_dayTimeDuration] = "dayTimeDuration",
  [anon_sym_yearMonthDuration] = "yearMonthDuration",
  [anon_sym_integer] = "integer",
  [anon_sym_long] = "long",
  [anon_sym_int] = "int",
  [anon_sym_short] = "short",
  [anon_sym_byte] = "byte",
  [anon_sym_nonNegativeInteger] = "nonNegativeInteger",
  [anon_sym_positiveInteger] = "positiveInteger",
  [anon_sym_unsignedLong] = "unsignedLong",
  [anon_sym_unsignedInt] = "unsignedInt",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_unsignedShort] = "unsignedShort",
  [anon_sym_unsignedByte] = "unsignedByte",
  [anon_sym_nonPositiveInteger] = "nonPositiveInteger",
  [anon_sym_negativeInteger] = "negativeInteger",
  [anon_sym_normalizedString] = "normalizedString",
  [anon_sym_token] = "token",
  [anon_sym_language] = "language",
  [sym_quoted_string] = "quoted_string",
  [sym_language_tag] = "language_tag",
  [anon_sym_LT] = "<",
  [aux_sym_iri_token1] = "iri_token1",
  [anon_sym_GT] = ">",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_hex_byte] = "hex_byte",
  [sym_double] = "double",
  [sym_decimal] = "decimal",
  [sym_integer] = "integer",
  [sym_rational] = "rational",
  [sym_unsigned] = "unsigned",
  [anon_sym_true] = "true",
  [anon_sym_u22a4] = "\u22a4",
  [anon_sym_false] = "false",
  [anon_sym_u22a5] = "\u22a5",
  [anon_sym_datatype] = "datatype",
  [sym_opaque] = "opaque",
  [anon_sym_length] = "length",
  [anon_sym_maxLength] = "maxLength",
  [anon_sym_minLength] = "minLength",
  [anon_sym_fractionDigits] = "fractionDigits",
  [anon_sym_totalDigits] = "totalDigits",
  [anon_sym_maxExclusive] = "maxExclusive",
  [anon_sym_maxInclusive] = "maxInclusive",
  [anon_sym_minExclusive] = "minExclusive",
  [anon_sym_minInclusive] = "minInclusive",
  [anon_sym_explicitTimezone] = "explicitTimezone",
  [anon_sym_required] = "required",
  [anon_sym_prohibited] = "prohibited",
  [anon_sym_optional] = "optional",
  [anon_sym_pattern] = "pattern",
  [sym_kw_is_fixed] = "kw_is_fixed",
  [anon_sym_dimension] = "dimension",
  [anon_sym_source] = "source",
  [anon_sym_parent] = "parent",
  [anon_sym_entity] = "entity",
  [anon_sym_enum] = "enum",
  [anon_sym_of] = "of",
  [anon_sym_event] = "event",
  [anon_sym_property] = "property",
  [anon_sym_structure] = "structure",
  [anon_sym_union] = "union",
  [anon_sym_rdf] = "rdf",
  [anon_sym_a] = "a",
  [anon_sym_type] = "type",
  [anon_sym_class] = "class",
  [sym_wildcard] = "wildcard",
  [anon_sym_identity] = "identity",
  [anon_sym_ref] = "ref",
  [sym_unknown_type] = "unknown_type",
  [anon_sym_ordered] = "ordered",
  [anon_sym_unordered] = "unordered",
  [anon_sym_unique] = "unique",
  [anon_sym_nonunique] = "nonunique",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_u2260] = "\u2260",
  [sym_op_less_than] = "op_less_than",
  [sym_op_greater_than] = "op_greater_than",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_u2264] = "\u2264",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_u2265] = "\u2265",
  [anon_sym_not] = "not",
  [anon_sym_u00ac] = "\u00ac",
  [anon_sym_and] = "and",
  [anon_sym_u2227] = "\u2227",
  [anon_sym_or] = "or",
  [anon_sym_u2228] = "\u2228",
  [anon_sym_xor] = "xor",
  [anon_sym_u22bb] = "\u22bb",
  [anon_sym_implies] = "implies",
  [anon_sym_EQ_EQ_GT] = "==>",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_iff] = "iff",
  [anon_sym_LT_EQ_EQ_GT] = "<==>",
  [anon_sym_u21d4] = "\u21d4",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_exists] = "exists",
  [anon_sym_u2203] = "\u2203",
  [anon_sym_u222a] = "\u222a",
  [anon_sym_intersection] = "intersection",
  [anon_sym_u2229] = "\u2229",
  [anon_sym_subset] = "subset",
  [anon_sym_u2282] = "\u2282",
  [anon_sym_subseteq] = "subseteq",
  [anon_sym_u2286] = "\u2286",
  [anon_sym_complement] = "complement",
  [anon_sym_u2216] = "\u2216",
  [anon_sym_in] = "in",
  [anon_sym_u2208] = "\u2208",
  [sym_set_op_builder] = "set_op_builder",
  [anon_sym_u00b7] = "\u00b7",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_u2254] = "\u2254",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_PLUS] = "+",
  [anon_sym_u2295] = "\u2295",
  [sym__value_empty_sequence] = "_value_empty_sequence",
  [sym_line_comment] = "line_comment",
  [sym_module] = "module",
  [sym__module_locations] = "_module_locations",
  [sym_module_body] = "module_body",
  [sym_import_statement] = "import_statement",
  [sym_from_clause] = "from_clause",
  [sym_module_path_root_only] = "module_path_root_only",
  [sym_module_path_absolute] = "module_path_absolute",
  [sym_module_path_relative] = "module_path_relative",
  [sym__import] = "_import",
  [sym__rename_import] = "_rename_import",
  [sym_member_import] = "member_import",
  [sym_module_import] = "module_import",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_identifier_reference] = "identifier_reference",
  [sym_annotation] = "annotation",
  [sym_annotation_property] = "annotation_property",
  [sym_constraint] = "constraint",
  [sym_informal_constraint] = "informal_constraint",
  [sym_formal_constraint] = "formal_constraint",
  [sym_constraint_sentence] = "constraint_sentence",
  [sym_simple_sentence] = "simple_sentence",
  [sym_atomic_sentence] = "atomic_sentence",
  [sym__actual_arguments] = "_actual_arguments",
  [sym_equation] = "equation",
  [sym_inequation] = "inequation",
  [sym_boolean_sentence] = "boolean_sentence",
  [sym_unary_boolean_sentence] = "unary_boolean_sentence",
  [sym_binary_boolean_sentence] = "binary_boolean_sentence",
  [sym__logical_connective] = "_logical_connective",
  [sym_quantified_sentence] = "quantified_sentence",
  [sym_quantified_variable_binding] = "quantified_variable_binding",
  [sym_quantified_variable] = "quantified_variable",
  [sym_variable] = "variable",
  [sym_term] = "term",
  [sym_functional_term] = "functional_term",
  [sym_function_composition] = "function_composition",
  [sym_predicate_value] = "predicate_value",
  [sym_sequence_of_predicate_values] = "sequence_of_predicate_values",
  [sym_constraint_environment] = "constraint_environment",
  [sym_function_def] = "function_def",
  [sym_function_signature] = "function_signature",
  [sym_function_parameter] = "function_parameter",
  [sym__function_type] = "_function_type",
  [sym_function_cardinality_expression] = "function_cardinality_expression",
  [sym_function_type_reference] = "function_type_reference",
  [sym_function_body] = "function_body",
  [sym_sequence_builder] = "sequence_builder",
  [sym_sequence_builder_body] = "sequence_builder_body",
  [sym_value] = "value",
  [sym_sequence_of_values] = "sequence_of_values",
  [sym__sequence_value_constraints] = "_sequence_value_constraints",
  [sym_value_constructor] = "value_constructor",
  [sym_mapping_value] = "mapping_value",
  [sym_builtin_simple_type] = "builtin_simple_type",
  [sym__owl_builtin_types] = "_owl_builtin_types",
  [sym__builtin_primitive_datatypes] = "_builtin_primitive_datatypes",
  [sym__derived_date_datetypes] = "_derived_date_datetypes",
  [sym__derived_numeric_datatypes] = "_derived_numeric_datatypes",
  [sym__derived_string_datatypes] = "_derived_string_datatypes",
  [sym_simple_value] = "simple_value",
  [sym_string] = "string",
  [sym_iri] = "iri",
  [sym_binary] = "binary",
  [sym_boolean] = "boolean",
  [sym_boolean_truth] = "boolean_truth",
  [sym_boolean_falsity] = "boolean_falsity",
  [sym_definition] = "definition",
  [sym_data_type_def] = "data_type_def",
  [sym__datatype_base] = "_datatype_base",
  [sym_datatype_def_restriction] = "datatype_def_restriction",
  [sym__restriction_facet] = "_restriction_facet",
  [sym_length_restriction_facet] = "length_restriction_facet",
  [sym_digit_restriction_facet] = "digit_restriction_facet",
  [sym_value_restriction_facet] = "value_restriction_facet",
  [sym_restriction_value] = "restriction_value",
  [sym_tz_restriction_facet] = "tz_restriction_facet",
  [sym_tz_restriction_value] = "tz_restriction_value",
  [sym_pattern_restriction_facet] = "pattern_restriction_facet",
  [sym_annotation_only_body] = "annotation_only_body",
  [sym_dimension_def] = "dimension_def",
  [sym_dimension_body] = "dimension_body",
  [sym_source_entity] = "source_entity",
  [sym__identifier_or_sequence] = "_identifier_or_sequence",
  [sym_dimension_parent] = "dimension_parent",
  [sym_entity_def] = "entity_def",
  [sym_entity_body] = "entity_body",
  [sym_enum_def] = "enum_def",
  [sym_enum_body] = "enum_body",
  [sym_event_def] = "event_def",
  [sym_event_body] = "event_body",
  [sym_property_def] = "property_def",
  [sym_structure_def] = "structure_def",
  [sym_structure_body] = "structure_body",
  [sym_union_def] = "union_def",
  [sym_union_body] = "union_body",
  [sym_rdf_def] = "rdf_def",
  [sym_rdf_types] = "rdf_types",
  [sym_type_class_def] = "type_class_def",
  [sym_type_variable] = "type_variable",
  [sym_type_variable_restriction] = "type_variable_restriction",
  [sym_type_class_reference] = "type_class_reference",
  [sym_type_class_arguments] = "type_class_arguments",
  [sym_type_class_body] = "type_class_body",
  [sym_method_def] = "method_def",
  [sym_entity_identity] = "entity_identity",
  [sym_member] = "member",
  [sym_member_def] = "member_def",
  [sym_property_ref] = "property_ref",
  [sym__type_expression_to] = "_type_expression_to",
  [sym_type_reference] = "type_reference",
  [sym_mapping_type] = "mapping_type",
  [sym_cardinality_expression] = "cardinality_expression",
  [sym__cardinality_inner] = "_cardinality_inner",
  [sym_sequence_ordering] = "sequence_ordering",
  [sym_sequence_uniqueness] = "sequence_uniqueness",
  [sym_cardinality_range] = "cardinality_range",
  [sym_value_variant] = "value_variant",
  [sym_type_variant] = "type_variant",
  [sym_op_inequality] = "op_inequality",
  [sym_op_less_than_or_equal] = "op_less_than_or_equal",
  [sym_op_greater_than_or_equal] = "op_greater_than_or_equal",
  [sym_logical_op_negation] = "logical_op_negation",
  [sym_logical_op_conjunction] = "logical_op_conjunction",
  [sym_logical_op_disjunction] = "logical_op_disjunction",
  [sym_logical_op_exclusive_disjunction] = "logical_op_exclusive_disjunction",
  [sym_logical_op_implication] = "logical_op_implication",
  [sym_logical_op_biconditional] = "logical_op_biconditional",
  [sym_logical_quantifier_universal] = "logical_quantifier_universal",
  [sym_logical_quantifier_existential] = "logical_quantifier_existential",
  [sym_set_op_membership] = "set_op_membership",
  [sym__function_op_composition] = "_function_op_composition",
  [sym__function_op_by_definition] = "_function_op_by_definition",
  [sym__type_op_has_type] = "_type_op_has_type",
  [sym__type_op_type_restriction] = "_type_op_type_restriction",
  [sym_type_op_combiner] = "type_op_combiner",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_module_body_repeat2] = "module_body_repeat2",
  [aux_sym_module_body_repeat3] = "module_body_repeat3",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_module_path_absolute_repeat1] = "module_path_absolute_repeat1",
  [aux_sym__actual_arguments_repeat1] = "_actual_arguments_repeat1",
  [aux_sym_function_composition_repeat1] = "function_composition_repeat1",
  [aux_sym_sequence_of_predicate_values_repeat1] = "sequence_of_predicate_values_repeat1",
  [aux_sym_constraint_environment_repeat1] = "constraint_environment_repeat1",
  [aux_sym_function_signature_repeat1] = "function_signature_repeat1",
  [aux_sym_sequence_builder_repeat1] = "sequence_builder_repeat1",
  [aux_sym_sequence_of_values_repeat1] = "sequence_of_values_repeat1",
  [aux_sym_binary_repeat1] = "binary_repeat1",
  [aux_sym_datatype_def_restriction_repeat1] = "datatype_def_restriction_repeat1",
  [aux_sym_pattern_restriction_facet_repeat1] = "pattern_restriction_facet_repeat1",
  [aux_sym_dimension_body_repeat1] = "dimension_body_repeat1",
  [aux_sym_dimension_body_repeat2] = "dimension_body_repeat2",
  [aux_sym__identifier_or_sequence_repeat1] = "_identifier_or_sequence_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_union_body_repeat1] = "union_body_repeat1",
  [aux_sym_rdf_types_repeat1] = "rdf_types_repeat1",
  [aux_sym_type_class_def_repeat1] = "type_class_def_repeat1",
  [aux_sym_type_variable_restriction_repeat1] = "type_variable_restriction_repeat1",
  [aux_sym_type_class_arguments_repeat1] = "type_class_arguments_repeat1",
  [aux_sym_type_class_body_repeat1] = "type_class_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_version] = anon_sym_version,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_assert] = anon_sym_assert,
  [sym_controlled_language_tag] = sym_controlled_language_tag,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_reserved_self] = sym_reserved_self,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_Thing] = anon_sym_Thing,
  [anon_sym_Nothing] = anon_sym_Nothing,
  [anon_sym_real] = anon_sym_real,
  [anon_sym_rational] = anon_sym_rational,
  [anon_sym_anyURI] = anon_sym_anyURI,
  [anon_sym_iri] = anon_sym_iri,
  [anon_sym_base64Binary] = anon_sym_base64Binary,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_date] = anon_sym_date,
  [anon_sym_dateTime] = anon_sym_dateTime,
  [anon_sym_decimal] = anon_sym_decimal,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_duration] = anon_sym_duration,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_gDay] = anon_sym_gDay,
  [anon_sym_gMonth] = anon_sym_gMonth,
  [anon_sym_gMonthDay] = anon_sym_gMonthDay,
  [anon_sym_gYearMonth] = anon_sym_gYearMonth,
  [anon_sym_gYear] = anon_sym_gYear,
  [anon_sym_hexBinary] = anon_sym_hexBinary,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_time] = anon_sym_time,
  [anon_sym_dateTimeStamp] = anon_sym_dateTimeStamp,
  [anon_sym_dayTimeDuration] = anon_sym_dayTimeDuration,
  [anon_sym_yearMonthDuration] = anon_sym_yearMonthDuration,
  [anon_sym_integer] = anon_sym_integer,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_nonNegativeInteger] = anon_sym_nonNegativeInteger,
  [anon_sym_positiveInteger] = anon_sym_positiveInteger,
  [anon_sym_unsignedLong] = anon_sym_unsignedLong,
  [anon_sym_unsignedInt] = anon_sym_unsignedInt,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_unsignedShort] = anon_sym_unsignedShort,
  [anon_sym_unsignedByte] = anon_sym_unsignedByte,
  [anon_sym_nonPositiveInteger] = anon_sym_nonPositiveInteger,
  [anon_sym_negativeInteger] = anon_sym_negativeInteger,
  [anon_sym_normalizedString] = anon_sym_normalizedString,
  [anon_sym_token] = anon_sym_token,
  [anon_sym_language] = anon_sym_language,
  [sym_quoted_string] = sym_quoted_string,
  [sym_language_tag] = sym_language_tag,
  [anon_sym_LT] = anon_sym_LT,
  [aux_sym_iri_token1] = aux_sym_iri_token1,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_hex_byte] = sym_hex_byte,
  [sym_double] = sym_double,
  [sym_decimal] = sym_decimal,
  [sym_integer] = sym_integer,
  [sym_rational] = sym_rational,
  [sym_unsigned] = sym_unsigned,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_u22a4] = anon_sym_u22a4,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_u22a5] = anon_sym_u22a5,
  [anon_sym_datatype] = anon_sym_datatype,
  [sym_opaque] = sym_opaque,
  [anon_sym_length] = anon_sym_length,
  [anon_sym_maxLength] = anon_sym_maxLength,
  [anon_sym_minLength] = anon_sym_minLength,
  [anon_sym_fractionDigits] = anon_sym_fractionDigits,
  [anon_sym_totalDigits] = anon_sym_totalDigits,
  [anon_sym_maxExclusive] = anon_sym_maxExclusive,
  [anon_sym_maxInclusive] = anon_sym_maxInclusive,
  [anon_sym_minExclusive] = anon_sym_minExclusive,
  [anon_sym_minInclusive] = anon_sym_minInclusive,
  [anon_sym_explicitTimezone] = anon_sym_explicitTimezone,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_prohibited] = anon_sym_prohibited,
  [anon_sym_optional] = anon_sym_optional,
  [anon_sym_pattern] = anon_sym_pattern,
  [sym_kw_is_fixed] = sym_kw_is_fixed,
  [anon_sym_dimension] = anon_sym_dimension,
  [anon_sym_source] = anon_sym_source,
  [anon_sym_parent] = anon_sym_parent,
  [anon_sym_entity] = anon_sym_entity,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_structure] = anon_sym_structure,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_rdf] = anon_sym_rdf,
  [anon_sym_a] = anon_sym_a,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_class] = anon_sym_class,
  [sym_wildcard] = sym_wildcard,
  [anon_sym_identity] = anon_sym_identity,
  [anon_sym_ref] = anon_sym_ref,
  [sym_unknown_type] = sym_unknown_type,
  [anon_sym_ordered] = anon_sym_ordered,
  [anon_sym_unordered] = anon_sym_unordered,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_nonunique] = anon_sym_nonunique,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_u2260] = anon_sym_u2260,
  [sym_op_less_than] = sym_op_less_than,
  [sym_op_greater_than] = sym_op_greater_than,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_u2264] = anon_sym_u2264,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_u2265] = anon_sym_u2265,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_u00ac] = anon_sym_u00ac,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_u2227] = anon_sym_u2227,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_u2228] = anon_sym_u2228,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_u22bb] = anon_sym_u22bb,
  [anon_sym_implies] = anon_sym_implies,
  [anon_sym_EQ_EQ_GT] = anon_sym_EQ_EQ_GT,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_iff] = anon_sym_iff,
  [anon_sym_LT_EQ_EQ_GT] = anon_sym_LT_EQ_EQ_GT,
  [anon_sym_u21d4] = anon_sym_u21d4,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_u2203] = anon_sym_u2203,
  [anon_sym_u222a] = anon_sym_u222a,
  [anon_sym_intersection] = anon_sym_intersection,
  [anon_sym_u2229] = anon_sym_u2229,
  [anon_sym_subset] = anon_sym_subset,
  [anon_sym_u2282] = anon_sym_u2282,
  [anon_sym_subseteq] = anon_sym_subseteq,
  [anon_sym_u2286] = anon_sym_u2286,
  [anon_sym_complement] = anon_sym_complement,
  [anon_sym_u2216] = anon_sym_u2216,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_u2208] = anon_sym_u2208,
  [sym_set_op_builder] = sym_set_op_builder,
  [anon_sym_u00b7] = anon_sym_u00b7,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_u2254] = anon_sym_u2254,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_u2295] = anon_sym_u2295,
  [sym__value_empty_sequence] = sym__value_empty_sequence,
  [sym_line_comment] = sym_line_comment,
  [sym_module] = sym_module,
  [sym__module_locations] = sym__module_locations,
  [sym_module_body] = sym_module_body,
  [sym_import_statement] = sym_import_statement,
  [sym_from_clause] = sym_from_clause,
  [sym_module_path_root_only] = sym_module_path_root_only,
  [sym_module_path_absolute] = sym_module_path_absolute,
  [sym_module_path_relative] = sym_module_path_relative,
  [sym__import] = sym__import,
  [sym__rename_import] = sym__rename_import,
  [sym_member_import] = sym_member_import,
  [sym_module_import] = sym_module_import,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_identifier_reference] = sym_identifier_reference,
  [sym_annotation] = sym_annotation,
  [sym_annotation_property] = sym_annotation_property,
  [sym_constraint] = sym_constraint,
  [sym_informal_constraint] = sym_informal_constraint,
  [sym_formal_constraint] = sym_formal_constraint,
  [sym_constraint_sentence] = sym_constraint_sentence,
  [sym_simple_sentence] = sym_simple_sentence,
  [sym_atomic_sentence] = sym_atomic_sentence,
  [sym__actual_arguments] = sym__actual_arguments,
  [sym_equation] = sym_equation,
  [sym_inequation] = sym_inequation,
  [sym_boolean_sentence] = sym_boolean_sentence,
  [sym_unary_boolean_sentence] = sym_unary_boolean_sentence,
  [sym_binary_boolean_sentence] = sym_binary_boolean_sentence,
  [sym__logical_connective] = sym__logical_connective,
  [sym_quantified_sentence] = sym_quantified_sentence,
  [sym_quantified_variable_binding] = sym_quantified_variable_binding,
  [sym_quantified_variable] = sym_quantified_variable,
  [sym_variable] = sym_variable,
  [sym_term] = sym_term,
  [sym_functional_term] = sym_functional_term,
  [sym_function_composition] = sym_function_composition,
  [sym_predicate_value] = sym_predicate_value,
  [sym_sequence_of_predicate_values] = sym_sequence_of_predicate_values,
  [sym_constraint_environment] = sym_constraint_environment,
  [sym_function_def] = sym_function_def,
  [sym_function_signature] = sym_function_signature,
  [sym_function_parameter] = sym_function_parameter,
  [sym__function_type] = sym__function_type,
  [sym_function_cardinality_expression] = sym_function_cardinality_expression,
  [sym_function_type_reference] = sym_function_type_reference,
  [sym_function_body] = sym_function_body,
  [sym_sequence_builder] = sym_sequence_builder,
  [sym_sequence_builder_body] = sym_sequence_builder_body,
  [sym_value] = sym_value,
  [sym_sequence_of_values] = sym_sequence_of_values,
  [sym__sequence_value_constraints] = sym__sequence_value_constraints,
  [sym_value_constructor] = sym_value_constructor,
  [sym_mapping_value] = sym_mapping_value,
  [sym_builtin_simple_type] = sym_builtin_simple_type,
  [sym__owl_builtin_types] = sym__owl_builtin_types,
  [sym__builtin_primitive_datatypes] = sym__builtin_primitive_datatypes,
  [sym__derived_date_datetypes] = sym__derived_date_datetypes,
  [sym__derived_numeric_datatypes] = sym__derived_numeric_datatypes,
  [sym__derived_string_datatypes] = sym__derived_string_datatypes,
  [sym_simple_value] = sym_simple_value,
  [sym_string] = sym_string,
  [sym_iri] = sym_iri,
  [sym_binary] = sym_binary,
  [sym_boolean] = sym_boolean,
  [sym_boolean_truth] = sym_boolean_truth,
  [sym_boolean_falsity] = sym_boolean_falsity,
  [sym_definition] = sym_definition,
  [sym_data_type_def] = sym_data_type_def,
  [sym__datatype_base] = sym__datatype_base,
  [sym_datatype_def_restriction] = sym_datatype_def_restriction,
  [sym__restriction_facet] = sym__restriction_facet,
  [sym_length_restriction_facet] = sym_length_restriction_facet,
  [sym_digit_restriction_facet] = sym_digit_restriction_facet,
  [sym_value_restriction_facet] = sym_value_restriction_facet,
  [sym_restriction_value] = sym_restriction_value,
  [sym_tz_restriction_facet] = sym_tz_restriction_facet,
  [sym_tz_restriction_value] = sym_tz_restriction_value,
  [sym_pattern_restriction_facet] = sym_pattern_restriction_facet,
  [sym_annotation_only_body] = sym_annotation_only_body,
  [sym_dimension_def] = sym_dimension_def,
  [sym_dimension_body] = sym_dimension_body,
  [sym_source_entity] = sym_source_entity,
  [sym__identifier_or_sequence] = sym__identifier_or_sequence,
  [sym_dimension_parent] = sym_dimension_parent,
  [sym_entity_def] = sym_entity_def,
  [sym_entity_body] = sym_entity_body,
  [sym_enum_def] = sym_enum_def,
  [sym_enum_body] = sym_enum_body,
  [sym_event_def] = sym_event_def,
  [sym_event_body] = sym_event_body,
  [sym_property_def] = sym_property_def,
  [sym_structure_def] = sym_structure_def,
  [sym_structure_body] = sym_structure_body,
  [sym_union_def] = sym_union_def,
  [sym_union_body] = sym_union_body,
  [sym_rdf_def] = sym_rdf_def,
  [sym_rdf_types] = sym_rdf_types,
  [sym_type_class_def] = sym_type_class_def,
  [sym_type_variable] = sym_type_variable,
  [sym_type_variable_restriction] = sym_type_variable_restriction,
  [sym_type_class_reference] = sym_type_class_reference,
  [sym_type_class_arguments] = sym_type_class_arguments,
  [sym_type_class_body] = sym_type_class_body,
  [sym_method_def] = sym_method_def,
  [sym_entity_identity] = sym_entity_identity,
  [sym_member] = sym_member,
  [sym_member_def] = sym_member_def,
  [sym_property_ref] = sym_property_ref,
  [sym__type_expression_to] = sym__type_expression_to,
  [sym_type_reference] = sym_type_reference,
  [sym_mapping_type] = sym_mapping_type,
  [sym_cardinality_expression] = sym_cardinality_expression,
  [sym__cardinality_inner] = sym__cardinality_inner,
  [sym_sequence_ordering] = sym_sequence_ordering,
  [sym_sequence_uniqueness] = sym_sequence_uniqueness,
  [sym_cardinality_range] = sym_cardinality_range,
  [sym_value_variant] = sym_value_variant,
  [sym_type_variant] = sym_type_variant,
  [sym_op_inequality] = sym_op_inequality,
  [sym_op_less_than_or_equal] = sym_op_less_than_or_equal,
  [sym_op_greater_than_or_equal] = sym_op_greater_than_or_equal,
  [sym_logical_op_negation] = sym_logical_op_negation,
  [sym_logical_op_conjunction] = sym_logical_op_conjunction,
  [sym_logical_op_disjunction] = sym_logical_op_disjunction,
  [sym_logical_op_exclusive_disjunction] = sym_logical_op_exclusive_disjunction,
  [sym_logical_op_implication] = sym_logical_op_implication,
  [sym_logical_op_biconditional] = sym_logical_op_biconditional,
  [sym_logical_quantifier_universal] = sym_logical_quantifier_universal,
  [sym_logical_quantifier_existential] = sym_logical_quantifier_existential,
  [sym_set_op_membership] = sym_set_op_membership,
  [sym__function_op_composition] = sym__function_op_composition,
  [sym__function_op_by_definition] = sym__function_op_by_definition,
  [sym__type_op_has_type] = sym__type_op_has_type,
  [sym__type_op_type_restriction] = sym__type_op_type_restriction,
  [sym_type_op_combiner] = sym_type_op_combiner,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_module_body_repeat2] = aux_sym_module_body_repeat2,
  [aux_sym_module_body_repeat3] = aux_sym_module_body_repeat3,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_module_path_absolute_repeat1] = aux_sym_module_path_absolute_repeat1,
  [aux_sym__actual_arguments_repeat1] = aux_sym__actual_arguments_repeat1,
  [aux_sym_function_composition_repeat1] = aux_sym_function_composition_repeat1,
  [aux_sym_sequence_of_predicate_values_repeat1] = aux_sym_sequence_of_predicate_values_repeat1,
  [aux_sym_constraint_environment_repeat1] = aux_sym_constraint_environment_repeat1,
  [aux_sym_function_signature_repeat1] = aux_sym_function_signature_repeat1,
  [aux_sym_sequence_builder_repeat1] = aux_sym_sequence_builder_repeat1,
  [aux_sym_sequence_of_values_repeat1] = aux_sym_sequence_of_values_repeat1,
  [aux_sym_binary_repeat1] = aux_sym_binary_repeat1,
  [aux_sym_datatype_def_restriction_repeat1] = aux_sym_datatype_def_restriction_repeat1,
  [aux_sym_pattern_restriction_facet_repeat1] = aux_sym_pattern_restriction_facet_repeat1,
  [aux_sym_dimension_body_repeat1] = aux_sym_dimension_body_repeat1,
  [aux_sym_dimension_body_repeat2] = aux_sym_dimension_body_repeat2,
  [aux_sym__identifier_or_sequence_repeat1] = aux_sym__identifier_or_sequence_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_union_body_repeat1] = aux_sym_union_body_repeat1,
  [aux_sym_rdf_types_repeat1] = aux_sym_rdf_types_repeat1,
  [aux_sym_type_class_def_repeat1] = aux_sym_type_class_def_repeat1,
  [aux_sym_type_variable_restriction_repeat1] = aux_sym_type_variable_restriction_repeat1,
  [aux_sym_type_class_arguments_repeat1] = aux_sym_type_class_arguments_repeat1,
  [aux_sym_type_class_body_repeat1] = aux_sym_type_class_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_version] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [sym_controlled_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_reserved_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Nothing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyURI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base64Binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_date] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decimal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_duration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonthDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYearMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hexBinary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_time] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTimeStamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dayTimeDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yearMonthDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonNegativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_positiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedLong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedShort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedByte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonPositiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_negativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_normalizedString] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_token] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_language] = {
    .visible = true,
    .named = false,
  },
  [sym_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iri_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_hex_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_unsigned] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_datatype] = {
    .visible = true,
    .named = false,
  },
  [sym_opaque] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_length] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fractionDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_totalDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicitTimezone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prohibited] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optional] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [sym_kw_is_fixed] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_dimension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_source] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_entity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_structure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rdf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_identity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [sym_unknown_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonunique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2260] = {
    .visible = true,
    .named = false,
  },
  [sym_op_less_than] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2264] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2265] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00ac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2227] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2228] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iff] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2203] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u222a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_intersection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2229] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2282] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2286] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_complement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = false,
  },
  [sym_set_op_builder] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u00b7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2254] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2295] = {
    .visible = true,
    .named = false,
  },
  [sym__value_empty_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module_locations] = {
    .visible = false,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_root_only] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_absolute] = {
    .visible = true,
    .named = true,
  },
  [sym_module_path_relative] = {
    .visible = true,
    .named = true,
  },
  [sym__import] = {
    .visible = false,
    .named = true,
  },
  [sym__rename_import] = {
    .visible = false,
    .named = true,
  },
  [sym_member_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_import] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_property] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_informal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym__actual_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_equation] = {
    .visible = true,
    .named = true,
  },
  [sym_inequation] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym__logical_connective] = {
    .visible = false,
    .named = true,
  },
  [sym_quantified_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_functional_term] = {
    .visible = true,
    .named = true,
  },
  [sym_function_composition] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_predicate_values] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_environment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder_body] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_values] = {
    .visible = true,
    .named = true,
  },
  [sym__sequence_value_constraints] = {
    .visible = false,
    .named = true,
  },
  [sym_value_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_value] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_simple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__owl_builtin_types] = {
    .visible = false,
    .named = true,
  },
  [sym__builtin_primitive_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_date_datetypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_numeric_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_string_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_value] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_iri] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_truth] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_falsity] = {
    .visible = true,
    .named = true,
  },
  [sym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_data_type_def] = {
    .visible = true,
    .named = true,
  },
  [sym__datatype_base] = {
    .visible = false,
    .named = true,
  },
  [sym_datatype_def_restriction] = {
    .visible = true,
    .named = true,
  },
  [sym__restriction_facet] = {
    .visible = false,
    .named = true,
  },
  [sym_length_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_digit_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_value_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_only_body] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_def] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_body] = {
    .visible = true,
    .named = true,
  },
  [sym_source_entity] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_dimension_parent] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_def] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_def] = {
    .visible = true,
    .named = true,
  },
  [sym_event_body] = {
    .visible = true,
    .named = true,
  },
  [sym_property_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_body] = {
    .visible = true,
    .named = true,
  },
  [sym_union_def] = {
    .visible = true,
    .named = true,
  },
  [sym_union_body] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_def] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_types] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_def] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable_restriction] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_method_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_identity] = {
    .visible = true,
    .named = true,
  },
  [sym_member] = {
    .visible = true,
    .named = true,
  },
  [sym_member_def] = {
    .visible = true,
    .named = true,
  },
  [sym_property_ref] = {
    .visible = true,
    .named = true,
  },
  [sym__type_expression_to] = {
    .visible = false,
    .named = true,
  },
  [sym_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cardinality_inner] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_ordering] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_uniqueness] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_range] = {
    .visible = true,
    .named = true,
  },
  [sym_value_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_op_inequality] = {
    .visible = true,
    .named = true,
  },
  [sym_op_less_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_exclusive_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_biconditional] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_universal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_existential] = {
    .visible = true,
    .named = true,
  },
  [sym_set_op_membership] = {
    .visible = true,
    .named = true,
  },
  [sym__function_op_composition] = {
    .visible = false,
    .named = true,
  },
  [sym__function_op_by_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__type_op_has_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_op_type_restriction] = {
    .visible = false,
    .named = true,
  },
  [sym_type_op_combiner] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_path_absolute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__actual_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_composition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_predicate_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_environment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_builder_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_binary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatype_def_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_restriction_facet_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_or_sequence_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rdf_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_variable_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_argument = 1,
  field_arguments = 2,
  field_base = 3,
  field_binding = 4,
  field_body = 5,
  field_byte = 6,
  field_cardinality = 7,
  field_domain = 8,
  field_element = 9,
  field_empty = 10,
  field_entity = 11,
  field_environment = 12,
  field_facet = 13,
  field_function = 14,
  field_identity = 15,
  field_is_fixed = 16,
  field_language = 17,
  field_lhs = 18,
  field_max = 19,
  field_member = 20,
  field_method = 21,
  field_min = 22,
  field_module = 23,
  field_name = 24,
  field_opaque = 25,
  field_operator = 26,
  field_ordering = 27,
  field_parameter = 28,
  field_predicate = 29,
  field_property = 30,
  field_quantifier = 31,
  field_range = 32,
  field_relation = 33,
  field_rename = 34,
  field_restriction = 35,
  field_rhs = 36,
  field_segment = 37,
  field_signature = 38,
  field_source = 39,
  field_subject = 40,
  field_target = 41,
  field_type = 42,
  field_types = 43,
  field_uniqueness = 44,
  field_value = 45,
  field_variable = 46,
  field_version_info = 47,
  field_version_uri = 48,
  field_wildcard = 49,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_base] = "base",
  [field_binding] = "binding",
  [field_body] = "body",
  [field_byte] = "byte",
  [field_cardinality] = "cardinality",
  [field_domain] = "domain",
  [field_element] = "element",
  [field_empty] = "empty",
  [field_entity] = "entity",
  [field_environment] = "environment",
  [field_facet] = "facet",
  [field_function] = "function",
  [field_identity] = "identity",
  [field_is_fixed] = "is_fixed",
  [field_language] = "language",
  [field_lhs] = "lhs",
  [field_max] = "max",
  [field_member] = "member",
  [field_method] = "method",
  [field_min] = "min",
  [field_module] = "module",
  [field_name] = "name",
  [field_opaque] = "opaque",
  [field_operator] = "operator",
  [field_ordering] = "ordering",
  [field_parameter] = "parameter",
  [field_predicate] = "predicate",
  [field_property] = "property",
  [field_quantifier] = "quantifier",
  [field_range] = "range",
  [field_relation] = "relation",
  [field_rename] = "rename",
  [field_restriction] = "restriction",
  [field_rhs] = "rhs",
  [field_segment] = "segment",
  [field_signature] = "signature",
  [field_source] = "source",
  [field_subject] = "subject",
  [field_target] = "target",
  [field_type] = "type",
  [field_types] = "types",
  [field_uniqueness] = "uniqueness",
  [field_value] = "value",
  [field_variable] = "variable",
  [field_version_info] = "version_info",
  [field_version_uri] = "version_uri",
  [field_wildcard] = "wildcard",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 5},
  [4] = {.index = 8, .length = 1},
  [5] = {.index = 9, .length = 1},
  [6] = {.index = 10, .length = 1},
  [7] = {.index = 11, .length = 1},
  [8] = {.index = 12, .length = 2},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 1},
  [12] = {.index = 19, .length = 2},
  [13] = {.index = 21, .length = 3},
  [14] = {.index = 24, .length = 3},
  [15] = {.index = 27, .length = 1},
  [16] = {.index = 28, .length = 2},
  [17] = {.index = 30, .length = 3},
  [18] = {.index = 33, .length = 2},
  [19] = {.index = 35, .length = 2},
  [20] = {.index = 37, .length = 1},
  [21] = {.index = 38, .length = 2},
  [22] = {.index = 40, .length = 1},
  [23] = {.index = 41, .length = 2},
  [24] = {.index = 43, .length = 4},
  [25] = {.index = 47, .length = 1},
  [26] = {.index = 48, .length = 1},
  [27] = {.index = 49, .length = 3},
  [28] = {.index = 52, .length = 1},
  [29] = {.index = 53, .length = 1},
  [30] = {.index = 54, .length = 1},
  [31] = {.index = 55, .length = 1},
  [32] = {.index = 56, .length = 1},
  [33] = {.index = 57, .length = 1},
  [34] = {.index = 58, .length = 3},
  [35] = {.index = 61, .length = 2},
  [36] = {.index = 63, .length = 1},
  [37] = {.index = 64, .length = 2},
  [38] = {.index = 66, .length = 2},
  [39] = {.index = 68, .length = 2},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 2},
  [42] = {.index = 74, .length = 2},
  [43] = {.index = 76, .length = 3},
  [44] = {.index = 79, .length = 3},
  [45] = {.index = 82, .length = 3},
  [46] = {.index = 85, .length = 1},
  [47] = {.index = 86, .length = 1},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 1},
  [50] = {.index = 90, .length = 2},
  [51] = {.index = 92, .length = 1},
  [52] = {.index = 93, .length = 1},
  [53] = {.index = 94, .length = 1},
  [54] = {.index = 95, .length = 2},
  [55] = {.index = 97, .length = 2},
  [56] = {.index = 99, .length = 2},
  [57] = {.index = 101, .length = 2},
  [58] = {.index = 103, .length = 2},
  [59] = {.index = 105, .length = 1},
  [60] = {.index = 106, .length = 2},
  [61] = {.index = 108, .length = 1},
  [62] = {.index = 109, .length = 1},
  [63] = {.index = 110, .length = 1},
  [64] = {.index = 111, .length = 2},
  [65] = {.index = 113, .length = 2},
  [66] = {.index = 115, .length = 2},
  [67] = {.index = 117, .length = 2},
  [68] = {.index = 119, .length = 3},
  [69] = {.index = 122, .length = 2},
  [70] = {.index = 124, .length = 2},
  [71] = {.index = 126, .length = 1},
  [72] = {.index = 127, .length = 3},
  [73] = {.index = 130, .length = 3},
  [74] = {.index = 133, .length = 2},
  [75] = {.index = 135, .length = 4},
  [76] = {.index = 139, .length = 4},
  [77] = {.index = 143, .length = 4},
  [78] = {.index = 147, .length = 1},
  [79] = {.index = 148, .length = 2},
  [80] = {.index = 150, .length = 2},
  [81] = {.index = 152, .length = 2},
  [82] = {.index = 154, .length = 1},
  [83] = {.index = 155, .length = 2},
  [84] = {.index = 157, .length = 1},
  [85] = {.index = 158, .length = 3},
  [86] = {.index = 161, .length = 3},
  [87] = {.index = 164, .length = 2},
  [88] = {.index = 166, .length = 2},
  [89] = {.index = 168, .length = 3},
  [90] = {.index = 171, .length = 2},
  [91] = {.index = 173, .length = 1},
  [92] = {.index = 174, .length = 2},
  [93] = {.index = 176, .length = 2},
  [94] = {.index = 178, .length = 1},
  [95] = {.index = 179, .length = 5},
  [96] = {.index = 184, .length = 1},
  [97] = {.index = 185, .length = 2},
  [98] = {.index = 187, .length = 1},
  [99] = {.index = 188, .length = 3},
  [100] = {.index = 191, .length = 3},
  [101] = {.index = 194, .length = 3},
  [102] = {.index = 197, .length = 2},
  [103] = {.index = 199, .length = 2},
  [104] = {.index = 201, .length = 2},
  [105] = {.index = 203, .length = 2},
  [106] = {.index = 205, .length = 1},
  [107] = {.index = 206, .length = 2},
  [108] = {.index = 208, .length = 2},
  [109] = {.index = 210, .length = 4},
  [110] = {.index = 214, .length = 4},
  [111] = {.index = 218, .length = 3},
  [112] = {.index = 221, .length = 2},
  [113] = {.index = 223, .length = 1},
  [114] = {.index = 224, .length = 2},
  [115] = {.index = 226, .length = 3},
  [116] = {.index = 229, .length = 1},
  [117] = {.index = 230, .length = 1},
  [118] = {.index = 231, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
    {field_name, 1},
  [2] =
    {field_base, 0},
  [3] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
    {field_version_info, 2, .inherited = true},
    {field_version_uri, 2, .inherited = true},
  [8] =
    {field_name, 0},
  [9] =
    {field_segment, 0},
  [10] =
    {field_name, 1},
  [11] =
    {field_member, 1},
  [12] =
    {field_base, 0},
    {field_version_uri, 2},
  [14] =
    {field_name, 0},
    {field_rename, 1, .inherited = true},
  [16] =
    {field_name, 0},
    {field_version_uri, 1},
  [18] =
    {field_segment, 1},
  [19] =
    {field_segment, 0},
    {field_segment, 1, .inherited = true},
  [21] =
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [24] =
    {field_base, 0},
    {field_version_info, 2},
    {field_version_uri, 3},
  [27] =
    {field_rename, 1},
  [28] =
    {field_member, 2},
    {field_module, 0},
  [30] =
    {field_name, 0},
    {field_rename, 2, .inherited = true},
    {field_version_uri, 1},
  [33] =
    {field_segment, 1},
    {field_segment, 2, .inherited = true},
  [35] =
    {field_segment, 0, .inherited = true},
    {field_segment, 1, .inherited = true},
  [37] =
    {field_empty, 0},
  [38] =
    {field_name, 1},
    {field_value, 3},
  [40] =
    {field_value, 1},
  [41] =
    {field_base, 3},
    {field_name, 1},
  [43] =
    {field_body, 2},
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [47] =
    {field_target, 1},
  [48] =
    {field_type, 1},
  [49] =
    {field_body, 3},
    {field_name, 1},
    {field_types, 2},
  [52] =
    {field_signature, 0},
  [53] =
    {field_method, 0},
  [54] =
    {field_variable, 0},
  [55] =
    {field_element, 0},
  [56] =
    {field_language, 1},
  [57] =
    {field_byte, 0},
  [58] =
    {field_empty, 1},
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [61] =
    {field_name, 1, .inherited = true},
    {field_subject, 0},
  [63] =
    {field_body, 1},
  [64] =
    {field_argument, 1, .inherited = true},
    {field_predicate, 0},
  [66] =
    {field_argument, 1, .inherited = true},
    {field_function, 0},
  [68] =
    {field_operator, 0},
    {field_rhs, 1},
  [70] =
    {field_binding, 1},
    {field_quantifier, 0},
  [72] =
    {field_language, 2},
    {field_value, 1},
  [74] =
    {field_body, 1},
    {field_signature, 0},
  [76] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
  [79] =
    {field_base, 3},
    {field_name, 1},
    {field_restriction, 4},
  [82] =
    {field_base, 3},
    {field_body, 4},
    {field_name, 1},
  [85] =
    {field_entity, 1},
  [86] =
    {field_identity, 1},
  [87] =
    {field_body, 1},
    {field_name, 0},
  [89] =
    {field_min, 0},
  [90] =
    {field_cardinality, 1},
    {field_target, 2},
  [92] =
    {field_property, 1},
  [93] =
    {field_type, 0},
  [94] =
    {field_method, 1, .inherited = true},
  [95] =
    {field_method, 0, .inherited = true},
    {field_method, 1, .inherited = true},
  [97] =
    {field_name, 0},
    {field_restriction, 1},
  [99] =
    {field_cardinality, 0},
    {field_name, 1},
  [101] =
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [103] =
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [105] =
    {field_element, 1, .inherited = true},
  [106] =
    {field_element, 0, .inherited = true},
    {field_element, 1, .inherited = true},
  [108] =
    {field_ordering, 1},
  [109] =
    {field_uniqueness, 1},
  [110] =
    {field_byte, 1, .inherited = true},
  [111] =
    {field_byte, 0, .inherited = true},
    {field_byte, 1, .inherited = true},
  [113] =
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [115] =
    {field_domain, 0},
    {field_range, 2},
  [117] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [119] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [122] =
    {field_binding, 0},
    {field_body, 2},
  [124] =
    {field_lhs, 0},
    {field_rhs, 2},
  [126] =
    {field_argument, 0},
  [127] =
    {field_lhs, 0},
    {field_relation, 1},
    {field_rhs, 2},
  [130] =
    {field_cardinality, 2, .inherited = true},
    {field_name, 1},
    {field_target, 2, .inherited = true},
  [133] =
    {field_body, 2},
    {field_environment, 0},
  [135] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [139] =
    {field_base, 4},
    {field_body, 5},
    {field_name, 1},
    {field_opaque, 3},
  [143] =
    {field_base, 3},
    {field_body, 5},
    {field_name, 1},
    {field_restriction, 4},
  [147] =
    {field_identity, 2},
  [148] =
    {field_min, 0},
    {field_range, 1},
  [150] =
    {field_min, 1, .inherited = true},
    {field_range, 1, .inherited = true},
  [152] =
    {field_name, 0},
    {field_rename, 2},
  [154] =
    {field_type, 2, .inherited = true},
  [155] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [157] =
    {field_method, 2, .inherited = true},
  [158] =
    {field_cardinality, 0},
    {field_name, 1},
    {field_restriction, 2},
  [161] =
    {field_body, 5},
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [164] =
    {field_ordering, 1},
    {field_uniqueness, 2},
  [166] =
    {field_name, 0},
    {field_value, 2},
  [168] =
    {field_element, 2, .inherited = true},
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [171] =
    {field_name, 0},
    {field_range, 2},
  [173] =
    {field_argument, 1, .inherited = true},
  [174] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [176] =
    {field_source, 2},
    {field_variable, 0},
  [178] =
    {field_parameter, 0},
  [179] =
    {field_base, 4},
    {field_body, 6},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [184] =
    {field_member, 0},
  [185] =
    {field_entity, 1},
    {field_member, 3, .inherited = true},
  [187] =
    {field_max, 1},
  [188] =
    {field_min, 2, .inherited = true},
    {field_ordering, 1},
    {field_range, 2, .inherited = true},
  [191] =
    {field_min, 2, .inherited = true},
    {field_range, 2, .inherited = true},
    {field_uniqueness, 1},
  [194] =
    {field_body, 3},
    {field_name, 0},
    {field_rename, 2},
  [197] =
    {field_arguments, 1},
    {field_name, 0},
  [199] =
    {field_body, 3},
    {field_variable, 1, .inherited = true},
  [201] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [203] =
    {field_facet, 0},
    {field_value, 2},
  [205] =
    {field_value, 2},
  [206] =
    {field_entity, 3},
    {field_name, 1},
  [208] =
    {field_domain, 1},
    {field_range, 3},
  [210] =
    {field_min, 3, .inherited = true},
    {field_ordering, 1},
    {field_range, 3, .inherited = true},
    {field_uniqueness, 2},
  [214] =
    {field_cardinality, 5, .inherited = true},
    {field_name, 1},
    {field_parameter, 3, .inherited = true},
    {field_target, 5, .inherited = true},
  [218] =
    {field_facet, 0},
    {field_is_fixed, 2},
    {field_value, 3},
  [221] =
    {field_is_fixed, 2},
    {field_value, 3},
  [223] =
    {field_member, 1, .inherited = true},
  [224] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [226] =
    {field_body, 4},
    {field_entity, 3},
    {field_name, 1},
  [229] =
    {field_wildcard, 1},
  [230] =
    {field_variable, 1, .inherited = true},
  [231] =
    {field_value, 2},
    {field_value, 3},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 21,
  [27] = 27,
  [28] = 22,
  [29] = 25,
  [30] = 20,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 47,
  [50] = 48,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 66,
  [71] = 71,
  [72] = 72,
  [73] = 68,
  [74] = 69,
  [75] = 75,
  [76] = 75,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 81,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 96,
  [104] = 96,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 62,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 7,
  [114] = 67,
  [115] = 77,
  [116] = 3,
  [117] = 2,
  [118] = 71,
  [119] = 5,
  [120] = 120,
  [121] = 72,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 12,
  [126] = 126,
  [127] = 10,
  [128] = 14,
  [129] = 6,
  [130] = 9,
  [131] = 8,
  [132] = 11,
  [133] = 133,
  [134] = 134,
  [135] = 80,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 137,
  [140] = 140,
  [141] = 138,
  [142] = 142,
  [143] = 142,
  [144] = 144,
  [145] = 85,
  [146] = 90,
  [147] = 136,
  [148] = 91,
  [149] = 149,
  [150] = 150,
  [151] = 95,
  [152] = 94,
  [153] = 93,
  [154] = 87,
  [155] = 155,
  [156] = 86,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 92,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 45,
  [167] = 89,
  [168] = 88,
  [169] = 169,
  [170] = 160,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 198,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 212,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 296,
  [300] = 297,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 149,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 45,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 380,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 194,
  [408] = 408,
  [409] = 409,
  [410] = 187,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 437,
  [440] = 440,
  [441] = 441,
  [442] = 438,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 454,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 523,
  [528] = 505,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 537,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 494,
  [549] = 549,
  [550] = 550,
  [551] = 509,
  [552] = 549,
  [553] = 553,
  [554] = 554,
  [555] = 555,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba}, {0x1bc, 0x1bf}, {0x1c4, 0x1c4},
  {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x560, 0x588}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15},
  {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d},
  {0x1f80, 0x1f87}, {0x1f90, 0x1f97}, {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e},
  {0xa790, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xab30, 0xab5a}, {0xab60, 0xab68},
  {0xab70, 0xabbf}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba},
  {0x1bc, 0x1bf}, {0x1c4, 0x1c4}, {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x560, 0x588}, {0x660, 0x669}, {0x6f0, 0x6f9}, {0x7c0, 0x7c9}, {0x966, 0x96f},
  {0x9e6, 0x9ef}, {0xa66, 0xa6f}, {0xae6, 0xaef}, {0xb66, 0xb6f}, {0xbe6, 0xbef}, {0xc66, 0xc6f}, {0xce6, 0xcef}, {0xd66, 0xd6f},
  {0xde6, 0xdef}, {0xe50, 0xe59}, {0xed0, 0xed9}, {0xf20, 0xf29}, {0x1040, 0x1049}, {0x1090, 0x1099}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7},
  {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x17e0, 0x17e9}, {0x1810, 0x1819}, {0x1946, 0x194f},
  {0x19d0, 0x19d9}, {0x1a80, 0x1a89}, {0x1a90, 0x1a99}, {0x1b50, 0x1b59}, {0x1bb0, 0x1bb9}, {0x1c40, 0x1c49}, {0x1c50, 0x1c59}, {0x1c80, 0x1c88},
  {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45},
  {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1f87}, {0x1f90, 0x1f97},
  {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb},
  {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d},
  {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0xa620, 0xa629}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e}, {0xa790, 0xa7ca},
  {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xa8d0, 0xa8d9}, {0xa900, 0xa909}, {0xa9d0, 0xa9d9},
  {0xa9f0, 0xa9f9}, {0xaa50, 0xaa59}, {0xab30, 0xab5a}, {0xab60, 0xab68}, {0xab70, 0xabbf}, {0xabf0, 0xabf9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(71);
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 12,
        '.', 169,
        '/', 23,
        '0', 132,
        ':', 79,
        ';', 188,
        '<', 143,
        '=', 84,
        '>', 145,
        '@', 82,
        '[', 72,
        '\\', 14,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xac, 150,
        0xb7, 167,
        0x2190, 174,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x2208, 165,
        0x2216, 164,
        0x2227, 151,
        0x2228, 152,
        0x2229, 161,
        0x222a, 160,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2282, 162,
        0x2286, 163,
        0x2295, 177,
        0x22a4, 137,
        0x22a5, 138,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '.', 168,
        '0', 129,
        ':', 78,
        ';', 188,
        '<', 117,
        '>', 121,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        '}', 100,
        0xac, 150,
        0xb7, 167,
        0x2192, 172,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ':', 17,
        ';', 188,
        '<', 117,
        '@', 66,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        0x2192, 172,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ';', 188,
        '<', 117,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        '}', 100,
        0xac, 150,
        0x2192, 172,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 13,
        '-', 12,
        '0', 129,
        ';', 188,
        '<', 117,
        '[', 72,
        '\\', 14,
        ']', 73,
        '{', 99,
        0x2192, 172,
        0x2205, 178,
        0x22a4, 137,
        0x22a5, 138,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(101);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead > 0x08 &&
          (lookahead < 0x0b || 0x1f < lookahead) &&
          lookahead != 0x7f) ADVANCE(5);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 25,
        '.', 168,
        '/', 23,
        '0', 135,
        ':', 80,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xb7, 167,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2208, 165,
        0x2227, 151,
        0x2228, 152,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2295, 177,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 25,
        '/', 23,
        '0', 135,
        ':', 24,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2208, 165,
        0x2227, 151,
        0x2228, 152,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2295, 177,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        ',', 98,
        '-', 25,
        '.', 11,
        '/', 23,
        ':', 18,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 81,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2227, 151,
        0x2228, 152,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '(', 96,
        ')', 97,
        ',', 98,
        '-', 25,
        '.', 11,
        '/', 23,
        ':', 18,
        ';', 188,
        '<', 144,
        '=', 84,
        '>', 145,
        '@', 83,
        '}', 100,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2227, 151,
        0x2228, 152,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 10:
      if (lookahead == '-') ADVANCE(175);
      END_STATE();
    case 11:
      if (lookahead == '.') ADVANCE(140);
      END_STATE();
    case 12:
      if (lookahead == '0') ADVANCE(129);
      if (lookahead == '>') ADVANCE(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 13:
      if (lookahead == '0') ADVANCE(129);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 14:
      if (lookahead == '0') ADVANCE(128);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 15:
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '\\') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 16:
      if (lookahead == '0') ADVANCE(125);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 17:
      if (lookahead == ':') ADVANCE(75);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(74);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(74);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 20:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == 0x2190) ADVANCE(174);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 21:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 0x2190) ADVANCE(174);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 22:
      if (lookahead == ';') ADVANCE(188);
      if (lookahead == ']') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(173);
      END_STATE();
    case 26:
      if (lookahead == '>') ADVANCE(154);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 28:
      if (lookahead == 'U') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == '[') ADVANCE(122);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(30);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        'u', 32,
        '"', 5,
        '/', 5,
        '\\', 5,
        'a', 5,
        'b', 5,
        'e', 5,
        'f', 5,
        'n', 5,
        'r', 5,
        't', 5,
        'v', 5,
      );
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(5);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 37:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 38:
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(102);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(59);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(60);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(61);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(62);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(63);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(40);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 58:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(69);
      END_STATE();
    case 59:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(114);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 60:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(102);
      END_STATE();
    case 61:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(102);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 62:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(115);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 63:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(116);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 64:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 65:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 66:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 67:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 68:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 69:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(95);
      END_STATE();
    case 70:
      if (eof) ADVANCE(71);
      ADVANCE_MAP(
        '"', 5,
        '#', 29,
        '(', 96,
        ')', 97,
        '+', 176,
        ',', 98,
        '-', 12,
        '.', 11,
        '/', 23,
        '0', 132,
        ':', 19,
        ';', 188,
        '<', 143,
        '=', 84,
        '>', 145,
        '@', 81,
        '[', 72,
        '\\', 14,
        ']', 73,
        '_', 139,
        '{', 99,
        '|', 166,
        '}', 100,
        0xac, 150,
        0x2190, 174,
        0x2192, 172,
        0x21d2, 155,
        0x21d4, 157,
        0x2200, 158,
        0x2203, 159,
        0x2205, 178,
        0x2208, 165,
        0x2216, 164,
        0x2227, 151,
        0x2228, 152,
        0x2229, 161,
        0x222a, 160,
        0x2254, 171,
        0x2260, 142,
        0x2264, 147,
        0x2265, 149,
        0x2282, 162,
        0x2286, 163,
        0x2295, 177,
        0x22a4, 137,
        0x22a5, 138,
        0x22bb, 153,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(77);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(30);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(26);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(58);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(58);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(89);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(93);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_quoted_string);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_language_tag);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(105);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(107);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(103);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(42);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(43);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(44);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(45);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(113);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(111);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(112);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == ';') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(179);
      if ((!eof && lookahead <= '\t') ||
          (0x0b <= lookahead && lookahead <= ' ') ||
          lookahead == '"' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(188);
      if (lookahead > ' ') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_hex_byte);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_hex_byte);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_double);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_double);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_decimal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_rational);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_unsigned);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_u22a4);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_u22a5);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_wildcard);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_u2260);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_op_less_than);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_op_less_than);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_op_greater_than);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '=') ADVANCE(27);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_u2264);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_u2265);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_u00ac);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_u2227);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_u2228);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_u22bb);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_GT);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT_EQ_EQ_GT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_u21d4);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_u2203);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_u222a);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_u2229);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_u2282);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_u2286);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_u2216);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_set_op_builder);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_u00b7);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(140);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_u2254);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_u2295);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym__value_empty_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == 'U') ADVANCE(187);
      if (lookahead == 'u') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'N', 1,
        'T', 2,
        'a', 3,
        'b', 4,
        'c', 5,
        'd', 6,
        'e', 7,
        'f', 8,
        'g', 9,
        'h', 10,
        'i', 11,
        'l', 12,
        'm', 13,
        'n', 14,
        'o', 15,
        'p', 16,
        'r', 17,
        's', 18,
        't', 19,
        'u', 20,
        'v', 21,
        'w', 22,
        'x', 23,
        'y', 24,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_a);
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 'v') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'i') ADVANCE(44);
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 9:
      if (lookahead == 'D') ADVANCE(48);
      if (lookahead == 'M') ADVANCE(49);
      if (lookahead == 'Y') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'm') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'p') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'd') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'r') ADVANCE(82);
      if (lookahead == 'y') ADVANCE(83);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(90);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(91);
      if (lookahead == 'y') ADVANCE(92);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(93);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(98);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(99);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(100);
      if (lookahead == 'y') ADVANCE(101);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(102);
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(104);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(105);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(107);
      if (lookahead == 't') ADVANCE(108);
      if (lookahead == 'u') ADVANCE(109);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == 'p') ADVANCE(112);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 44:
      if (lookahead == 'x') ADVANCE(114);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(119);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(120);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 51:
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 53:
      if (lookahead == 'f') ADVANCE(124);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 61:
      if (lookahead == 'x') ADVANCE(131);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 63:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(134);
      END_STATE();
    case 65:
      if (lookahead == 'n') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(140);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(141);
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 73:
      if (lookahead == 'f') ADVANCE(146);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(149);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 77:
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(154);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(155);
      END_STATE();
    case 81:
      if (lookahead == 'k') ADVANCE(156);
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 83:
      if (lookahead == 'p') ADVANCE(159);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(160);
      if (lookahead == 'k') ADVANCE(161);
      if (lookahead == 'o') ADVANCE(162);
      if (lookahead == 's') ADVANCE(163);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 87:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 89:
      if (lookahead == 'h') ADVANCE(168);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 92:
      if (lookahead == 'U') ADVANCE(170);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 98:
      if (lookahead == 's') ADVANCE(176);
      END_STATE();
    case 99:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 101:
      if (lookahead == 'T') ADVANCE(180);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 105:
      if (lookahead == 'b') ADVANCE(183);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(184);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 109:
      if (lookahead == 'm') ADVANCE(186);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(187);
      END_STATE();
    case 111:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 112:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 115:
      if (lookahead == 'a') ADVANCE(192);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(194);
      END_STATE();
    case 118:
      if (lookahead == 'm') ADVANCE(195);
      END_STATE();
    case 119:
      if (lookahead == 'y') ADVANCE(196);
      END_STATE();
    case 120:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 122:
      if (lookahead == 'B') ADVANCE(199);
      END_STATE();
    case 123:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_iff);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 'o') ADVANCE(202);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_iri);
      END_STATE();
    case 128:
      if (lookahead == 'g') ADVANCE(204);
      END_STATE();
    case 129:
      if (lookahead == 'g') ADVANCE(205);
      END_STATE();
    case 130:
      if (lookahead == 'g') ADVANCE(206);
      END_STATE();
    case 131:
      if (lookahead == 'E') ADVANCE(207);
      if (lookahead == 'I') ADVANCE(208);
      if (lookahead == 'L') ADVANCE(209);
      END_STATE();
    case 132:
      if (lookahead == 'E') ADVANCE(210);
      if (lookahead == 'I') ADVANCE(211);
      if (lookahead == 'L') ADVANCE(212);
      END_STATE();
    case 133:
      if (lookahead == 'u') ADVANCE(213);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 135:
      if (lookahead == 'N') ADVANCE(215);
      if (lookahead == 'P') ADVANCE(216);
      if (lookahead == 'u') ADVANCE(217);
      END_STATE();
    case 136:
      if (lookahead == 'm') ADVANCE(218);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 138:
      if (lookahead == 'q') ADVANCE(219);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 144:
      if (lookahead == 'h') ADVANCE(225);
      if (lookahead == 'p') ADVANCE(226);
      END_STATE();
    case 145:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_rdf);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 149:
      if (lookahead == 'u') ADVANCE(229);
      END_STATE();
    case 150:
      if (lookahead == 'f') ADVANCE(230);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 152:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(233);
      if (lookahead == 'u') ADVANCE(234);
      END_STATE();
    case 154:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(236);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(240);
      END_STATE();
    case 160:
      if (lookahead == 'o') ADVANCE(241);
      if (lookahead == 'q') ADVANCE(242);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(243);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(244);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 165:
      if (lookahead == 'h') ADVANCE(247);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 168:
      if (lookahead == 'i') ADVANCE(249);
      END_STATE();
    case 169:
      if (lookahead == 'g') ADVANCE(250);
      END_STATE();
    case 170:
      if (lookahead == 'R') ADVANCE(251);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(252);
      END_STATE();
    case 172:
      if (lookahead == '6') ADVANCE(253);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(254);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 176:
      if (lookahead == 's') ADVANCE(256);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_date);
      if (lookahead == 'T') ADVANCE(259);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(260);
      END_STATE();
    case 181:
      if (lookahead == 'm') ADVANCE(261);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 188:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(268);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 191:
      if (lookahead == 'd') ADVANCE(270);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(272);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_gDay);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(275);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(278);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 203:
      if (lookahead == 'g') ADVANCE(280);
      if (lookahead == 'r') ADVANCE(281);
      END_STATE();
    case 204:
      if (lookahead == 'u') ADVANCE(282);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 207:
      if (lookahead == 'x') ADVANCE(284);
      END_STATE();
    case 208:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 210:
      if (lookahead == 'x') ADVANCE(287);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 213:
      if (lookahead == 'l') ADVANCE(290);
      END_STATE();
    case 214:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 215:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(295);
      END_STATE();
    case 219:
      if (lookahead == 'u') ADVANCE(296);
      END_STATE();
    case 220:
      if (lookahead == 'o') ADVANCE(297);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(298);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(302);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 227:
      if (lookahead == 'o') ADVANCE(304);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_real);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_reserved_self);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(307);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(309);
      END_STATE();
    case 235:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_time);
      END_STATE();
    case 237:
      if (lookahead == 'n') ADVANCE(311);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(312);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 241:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 242:
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 243:
      if (lookahead == 'o') ADVANCE(315);
      END_STATE();
    case 244:
      if (lookahead == 'd') ADVANCE(316);
      END_STATE();
    case 245:
      if (lookahead == 'g') ADVANCE(317);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(318);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 248:
      if (lookahead == 'M') ADVANCE(319);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_Thing);
      END_STATE();
    case 251:
      if (lookahead == 'I') ADVANCE(321);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 253:
      if (lookahead == '4') ADVANCE(323);
      END_STATE();
    case 254:
      if (lookahead == 'y') ADVANCE(324);
      END_STATE();
    case 255:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 258:
      if (lookahead == 'y') ADVANCE(327);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(328);
      END_STATE();
    case 260:
      if (lookahead == 'm') ADVANCE(329);
      END_STATE();
    case 261:
      if (lookahead == 'a') ADVANCE(330);
      END_STATE();
    case 262:
      if (lookahead == 's') ADVANCE(331);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 264:
      if (lookahead == 'i') ADVANCE(333);
      END_STATE();
    case 265:
      if (lookahead == 'y') ADVANCE(334);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 267:
      if (lookahead == 's') ADVANCE(335);
      END_STATE();
    case 268:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_kw_is_fixed);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 272:
      if (lookahead == 'l') ADVANCE(337);
      END_STATE();
    case 273:
      if (lookahead == 'i') ADVANCE(338);
      END_STATE();
    case 274:
      if (lookahead == 'h') ADVANCE(339);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_gYear);
      if (lookahead == 'M') ADVANCE(340);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(341);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(342);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 281:
      if (lookahead == 's') ADVANCE(346);
      END_STATE();
    case 282:
      if (lookahead == 'a') ADVANCE(347);
      END_STATE();
    case 283:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 284:
      if (lookahead == 'c') ADVANCE(349);
      END_STATE();
    case 285:
      if (lookahead == 'c') ADVANCE(350);
      END_STATE();
    case 286:
      if (lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 287:
      if (lookahead == 'c') ADVANCE(352);
      END_STATE();
    case 288:
      if (lookahead == 'c') ADVANCE(353);
      END_STATE();
    case 289:
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(356);
      END_STATE();
    case 292:
      if (lookahead == 'g') ADVANCE(357);
      END_STATE();
    case 293:
      if (lookahead == 's') ADVANCE(358);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(359);
      END_STATE();
    case 295:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 297:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 299:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 301:
      if (lookahead == 'i') ADVANCE(366);
      END_STATE();
    case 302:
      if (lookahead == 'b') ADVANCE(367);
      END_STATE();
    case 303:
      if (lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 304:
      if (lookahead == 'n') ADVANCE(369);
      END_STATE();
    case 305:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 308:
      if (lookahead == 'g') ADVANCE(372);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(373);
      END_STATE();
    case 310:
      if (lookahead == 't') ADVANCE(374);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_token);
      END_STATE();
    case 312:
      if (lookahead == 'D') ADVANCE(375);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 315:
      if (lookahead == 'w') ADVANCE(377);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 317:
      if (lookahead == 'n') ADVANCE(379);
      END_STATE();
    case 318:
      if (lookahead == 'o') ADVANCE(380);
      END_STATE();
    case 319:
      if (lookahead == 'o') ADVANCE(381);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(382);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_anyURI);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 323:
      if (lookahead == 'B') ADVANCE(383);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 325:
      if (lookahead == 'n') ADVANCE(384);
      END_STATE();
    case 326:
      if (lookahead == 'm') ADVANCE(385);
      END_STATE();
    case 327:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 328:
      if (lookahead == 'm') ADVANCE(387);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(388);
      END_STATE();
    case 330:
      if (lookahead == 'l') ADVANCE(389);
      END_STATE();
    case 331:
      if (lookahead == 'i') ADVANCE(390);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 333:
      if (lookahead == 'o') ADVANCE(391);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_entity);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 336:
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 338:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_gMonth);
      if (lookahead == 'D') ADVANCE(394);
      END_STATE();
    case 340:
      if (lookahead == 'o') ADVANCE(395);
      END_STATE();
    case 341:
      if (lookahead == 'a') ADVANCE(396);
      END_STATE();
    case 342:
      if (lookahead == 't') ADVANCE(397);
      END_STATE();
    case 343:
      if (lookahead == 's') ADVANCE(398);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 345:
      if (lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 347:
      if (lookahead == 'g') ADVANCE(401);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_length);
      END_STATE();
    case 349:
      if (lookahead == 'l') ADVANCE(402);
      END_STATE();
    case 350:
      if (lookahead == 'l') ADVANCE(403);
      END_STATE();
    case 351:
      if (lookahead == 'g') ADVANCE(404);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(405);
      END_STATE();
    case 353:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 354:
      if (lookahead == 'g') ADVANCE(407);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 356:
      if (lookahead == 'v') ADVANCE(408);
      END_STATE();
    case 357:
      if (lookahead == 'a') ADVANCE(409);
      END_STATE();
    case 358:
      if (lookahead == 'i') ADVANCE(410);
      END_STATE();
    case 359:
      if (lookahead == 'q') ADVANCE(411);
      END_STATE();
    case 360:
      if (lookahead == 'i') ADVANCE(412);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_opaque);
      END_STATE();
    case 362:
      if (lookahead == 'a') ADVANCE(413);
      END_STATE();
    case 363:
      if (lookahead == 'd') ADVANCE(414);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 365:
      if (lookahead == 'n') ADVANCE(415);
      END_STATE();
    case 366:
      if (lookahead == 'v') ADVANCE(416);
      END_STATE();
    case 367:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 368:
      if (lookahead == 't') ADVANCE(418);
      END_STATE();
    case 369:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_source);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 373:
      if (lookahead == 'u') ADVANCE(421);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_subset);
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 375:
      if (lookahead == 'i') ADVANCE(423);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 377:
      if (lookahead == 'n') ADVANCE(424);
      END_STATE();
    case 378:
      if (lookahead == 'r') ADVANCE(425);
      END_STATE();
    case 379:
      if (lookahead == 'e') ADVANCE(426);
      END_STATE();
    case 380:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(428);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_Nothing);
      END_STATE();
    case 383:
      if (lookahead == 'i') ADVANCE(429);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 385:
      if (lookahead == 'e') ADVANCE(430);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 387:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 388:
      if (lookahead == 'D') ADVANCE(433);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_decimal);
      END_STATE();
    case 390:
      if (lookahead == 'o') ADVANCE(434);
      END_STATE();
    case 391:
      if (lookahead == 'n') ADVANCE(435);
      END_STATE();
    case 392:
      if (lookahead == 't') ADVANCE(436);
      END_STATE();
    case 393:
      if (lookahead == 'n') ADVANCE(437);
      END_STATE();
    case 394:
      if (lookahead == 'a') ADVANCE(438);
      END_STATE();
    case 395:
      if (lookahead == 'n') ADVANCE(439);
      END_STATE();
    case 396:
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 397:
      if (lookahead == 'y') ADVANCE(441);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_integer);
      END_STATE();
    case 400:
      if (lookahead == 'c') ADVANCE(442);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 402:
      if (lookahead == 'u') ADVANCE(444);
      END_STATE();
    case 403:
      if (lookahead == 'u') ADVANCE(445);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(446);
      END_STATE();
    case 405:
      if (lookahead == 'u') ADVANCE(447);
      END_STATE();
    case 406:
      if (lookahead == 'u') ADVANCE(448);
      END_STATE();
    case 407:
      if (lookahead == 't') ADVANCE(449);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(450);
      END_STATE();
    case 409:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 410:
      if (lookahead == 't') ADVANCE(452);
      END_STATE();
    case 411:
      if (lookahead == 'u') ADVANCE(453);
      END_STATE();
    case 412:
      if (lookahead == 'z') ADVANCE(454);
      END_STATE();
    case 413:
      if (lookahead == 'l') ADVANCE(455);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_ordered);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 416:
      if (lookahead == 'e') ADVANCE(456);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 418:
      if (lookahead == 'y') ADVANCE(458);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(459);
      END_STATE();
    case 420:
      if (lookahead == 'd') ADVANCE(460);
      END_STATE();
    case 421:
      if (lookahead == 'r') ADVANCE(461);
      END_STATE();
    case 422:
      if (lookahead == 'q') ADVANCE(462);
      END_STATE();
    case 423:
      if (lookahead == 'g') ADVANCE(463);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_unknown_type);
      END_STATE();
    case 425:
      if (lookahead == 'e') ADVANCE(464);
      END_STATE();
    case 426:
      if (lookahead == 'd') ADVANCE(465);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_version);
      END_STATE();
    case 428:
      if (lookahead == 't') ADVANCE(466);
      END_STATE();
    case 429:
      if (lookahead == 'n') ADVANCE(467);
      END_STATE();
    case 430:
      if (lookahead == 'n') ADVANCE(468);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_datatype);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_dateTime);
      if (lookahead == 'S') ADVANCE(469);
      END_STATE();
    case 433:
      if (lookahead == 'u') ADVANCE(470);
      END_STATE();
    case 434:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_duration);
      END_STATE();
    case 436:
      if (lookahead == 'T') ADVANCE(472);
      END_STATE();
    case 437:
      if (lookahead == 'D') ADVANCE(473);
      END_STATE();
    case 438:
      if (lookahead == 'y') ADVANCE(474);
      END_STATE();
    case 439:
      if (lookahead == 't') ADVANCE(475);
      END_STATE();
    case 440:
      if (lookahead == 'y') ADVANCE(476);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_identity);
      END_STATE();
    case 442:
      if (lookahead == 't') ADVANCE(477);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_language);
      END_STATE();
    case 444:
      if (lookahead == 's') ADVANCE(478);
      END_STATE();
    case 445:
      if (lookahead == 's') ADVANCE(479);
      END_STATE();
    case 446:
      if (lookahead == 'h') ADVANCE(480);
      END_STATE();
    case 447:
      if (lookahead == 's') ADVANCE(481);
      END_STATE();
    case 448:
      if (lookahead == 's') ADVANCE(482);
      END_STATE();
    case 449:
      if (lookahead == 'h') ADVANCE(483);
      END_STATE();
    case 450:
      if (lookahead == 'I') ADVANCE(484);
      END_STATE();
    case 451:
      if (lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 452:
      if (lookahead == 'i') ADVANCE(486);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_optional);
      END_STATE();
    case 456:
      if (lookahead == 'I') ADVANCE(489);
      END_STATE();
    case 457:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_rational);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(491);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_subseteq);
      END_STATE();
    case 463:
      if (lookahead == 'i') ADVANCE(492);
      END_STATE();
    case 464:
      if (lookahead == 'd') ADVANCE(493);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (lookahead == 'B') ADVANCE(494);
      if (lookahead == 'I') ADVANCE(495);
      if (lookahead == 'L') ADVANCE(496);
      if (lookahead == 'S') ADVANCE(497);
      END_STATE();
    case 466:
      if (lookahead == 'h') ADVANCE(498);
      END_STATE();
    case 467:
      if (lookahead == 'a') ADVANCE(499);
      END_STATE();
    case 468:
      if (lookahead == 't') ADVANCE(500);
      END_STATE();
    case 469:
      if (lookahead == 't') ADVANCE(501);
      END_STATE();
    case 470:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_dimension);
      END_STATE();
    case 472:
      if (lookahead == 'i') ADVANCE(503);
      END_STATE();
    case 473:
      if (lookahead == 'i') ADVANCE(504);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_gMonthDay);
      END_STATE();
    case 475:
      if (lookahead == 'h') ADVANCE(505);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_hexBinary);
      END_STATE();
    case 477:
      if (lookahead == 'i') ADVANCE(506);
      END_STATE();
    case 478:
      if (lookahead == 'i') ADVANCE(507);
      END_STATE();
    case 479:
      if (lookahead == 'i') ADVANCE(508);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_maxLength);
      END_STATE();
    case 481:
      if (lookahead == 'i') ADVANCE(509);
      END_STATE();
    case 482:
      if (lookahead == 'i') ADVANCE(510);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_minLength);
      END_STATE();
    case 484:
      if (lookahead == 'n') ADVANCE(511);
      END_STATE();
    case 485:
      if (lookahead == 'v') ADVANCE(512);
      END_STATE();
    case 486:
      if (lookahead == 'v') ADVANCE(513);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_nonunique);
      END_STATE();
    case 488:
      if (lookahead == 'd') ADVANCE(514);
      END_STATE();
    case 489:
      if (lookahead == 'n') ADVANCE(515);
      END_STATE();
    case 490:
      if (lookahead == 'd') ADVANCE(516);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_structure);
      END_STATE();
    case 492:
      if (lookahead == 't') ADVANCE(517);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_unordered);
      END_STATE();
    case 494:
      if (lookahead == 'y') ADVANCE(518);
      END_STATE();
    case 495:
      if (lookahead == 'n') ADVANCE(519);
      END_STATE();
    case 496:
      if (lookahead == 'o') ADVANCE(520);
      END_STATE();
    case 497:
      if (lookahead == 'h') ADVANCE(521);
      END_STATE();
    case 498:
      if (lookahead == 'D') ADVANCE(522);
      END_STATE();
    case 499:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_complement);
      END_STATE();
    case 501:
      if (lookahead == 'a') ADVANCE(524);
      END_STATE();
    case 502:
      if (lookahead == 'a') ADVANCE(525);
      END_STATE();
    case 503:
      if (lookahead == 'm') ADVANCE(526);
      END_STATE();
    case 504:
      if (lookahead == 'g') ADVANCE(527);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_gYearMonth);
      END_STATE();
    case 506:
      if (lookahead == 'o') ADVANCE(528);
      END_STATE();
    case 507:
      if (lookahead == 'v') ADVANCE(529);
      END_STATE();
    case 508:
      if (lookahead == 'v') ADVANCE(530);
      END_STATE();
    case 509:
      if (lookahead == 'v') ADVANCE(531);
      END_STATE();
    case 510:
      if (lookahead == 'v') ADVANCE(532);
      END_STATE();
    case 511:
      if (lookahead == 't') ADVANCE(533);
      END_STATE();
    case 512:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 514:
      if (lookahead == 'S') ADVANCE(536);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_prohibited);
      END_STATE();
    case 517:
      if (lookahead == 's') ADVANCE(538);
      END_STATE();
    case 518:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 519:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 520:
      if (lookahead == 'n') ADVANCE(541);
      END_STATE();
    case 521:
      if (lookahead == 'o') ADVANCE(542);
      END_STATE();
    case 522:
      if (lookahead == 'u') ADVANCE(543);
      END_STATE();
    case 523:
      if (lookahead == 'y') ADVANCE(544);
      END_STATE();
    case 524:
      if (lookahead == 'm') ADVANCE(545);
      END_STATE();
    case 525:
      if (lookahead == 't') ADVANCE(546);
      END_STATE();
    case 526:
      if (lookahead == 'e') ADVANCE(547);
      END_STATE();
    case 527:
      if (lookahead == 'i') ADVANCE(548);
      END_STATE();
    case 528:
      if (lookahead == 'n') ADVANCE(549);
      END_STATE();
    case 529:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 530:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 531:
      if (lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 532:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 533:
      if (lookahead == 'e') ADVANCE(554);
      END_STATE();
    case 534:
      if (lookahead == 'I') ADVANCE(555);
      END_STATE();
    case 535:
      if (lookahead == 'I') ADVANCE(556);
      END_STATE();
    case 536:
      if (lookahead == 't') ADVANCE(557);
      END_STATE();
    case 537:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_totalDigits);
      END_STATE();
    case 539:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_unsignedInt);
      END_STATE();
    case 541:
      if (lookahead == 'g') ADVANCE(560);
      END_STATE();
    case 542:
      if (lookahead == 'r') ADVANCE(561);
      END_STATE();
    case 543:
      if (lookahead == 'r') ADVANCE(562);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_base64Binary);
      END_STATE();
    case 545:
      if (lookahead == 'p') ADVANCE(563);
      END_STATE();
    case 546:
      if (lookahead == 'i') ADVANCE(564);
      END_STATE();
    case 547:
      if (lookahead == 'z') ADVANCE(565);
      END_STATE();
    case 548:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_intersection);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_maxExclusive);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_maxInclusive);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_minExclusive);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_minInclusive);
      END_STATE();
    case 554:
      if (lookahead == 'g') ADVANCE(567);
      END_STATE();
    case 555:
      if (lookahead == 'n') ADVANCE(568);
      END_STATE();
    case 556:
      if (lookahead == 'n') ADVANCE(569);
      END_STATE();
    case 557:
      if (lookahead == 'r') ADVANCE(570);
      END_STATE();
    case 558:
      if (lookahead == 'g') ADVANCE(571);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_unsignedByte);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_unsignedLong);
      END_STATE();
    case 561:
      if (lookahead == 't') ADVANCE(572);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_dateTimeStamp);
      END_STATE();
    case 564:
      if (lookahead == 'o') ADVANCE(574);
      END_STATE();
    case 565:
      if (lookahead == 'o') ADVANCE(575);
      END_STATE();
    case 566:
      if (lookahead == 's') ADVANCE(576);
      END_STATE();
    case 567:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 568:
      if (lookahead == 't') ADVANCE(578);
      END_STATE();
    case 569:
      if (lookahead == 't') ADVANCE(579);
      END_STATE();
    case 570:
      if (lookahead == 'i') ADVANCE(580);
      END_STATE();
    case 571:
      if (lookahead == 'e') ADVANCE(581);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_unsignedShort);
      END_STATE();
    case 573:
      if (lookahead == 't') ADVANCE(582);
      END_STATE();
    case 574:
      if (lookahead == 'n') ADVANCE(583);
      END_STATE();
    case 575:
      if (lookahead == 'n') ADVANCE(584);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_fractionDigits);
      END_STATE();
    case 577:
      if (lookahead == 'r') ADVANCE(585);
      END_STATE();
    case 578:
      if (lookahead == 'e') ADVANCE(586);
      END_STATE();
    case 579:
      if (lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 580:
      if (lookahead == 'n') ADVANCE(588);
      END_STATE();
    case 581:
      if (lookahead == 'r') ADVANCE(589);
      END_STATE();
    case 582:
      if (lookahead == 'i') ADVANCE(590);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_dayTimeDuration);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_negativeInteger);
      END_STATE();
    case 586:
      if (lookahead == 'g') ADVANCE(592);
      END_STATE();
    case 587:
      if (lookahead == 'g') ADVANCE(593);
      END_STATE();
    case 588:
      if (lookahead == 'g') ADVANCE(594);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_positiveInteger);
      END_STATE();
    case 590:
      if (lookahead == 'o') ADVANCE(595);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_explicitTimezone);
      END_STATE();
    case 592:
      if (lookahead == 'e') ADVANCE(596);
      END_STATE();
    case 593:
      if (lookahead == 'e') ADVANCE(597);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_normalizedString);
      END_STATE();
    case 595:
      if (lookahead == 'n') ADVANCE(598);
      END_STATE();
    case 596:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 597:
      if (lookahead == 'r') ADVANCE(600);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_yearMonthDuration);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_nonNegativeInteger);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_nonPositiveInteger);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 6},
  [2] = {.lex_state = 6},
  [3] = {.lex_state = 6},
  [4] = {.lex_state = 6},
  [5] = {.lex_state = 9},
  [6] = {.lex_state = 6},
  [7] = {.lex_state = 6},
  [8] = {.lex_state = 6},
  [9] = {.lex_state = 6},
  [10] = {.lex_state = 6},
  [11] = {.lex_state = 6},
  [12] = {.lex_state = 6},
  [13] = {.lex_state = 6},
  [14] = {.lex_state = 6},
  [15] = {.lex_state = 6},
  [16] = {.lex_state = 6},
  [17] = {.lex_state = 6},
  [18] = {.lex_state = 6},
  [19] = {.lex_state = 6},
  [20] = {.lex_state = 1},
  [21] = {.lex_state = 1},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 6},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 1},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 1},
  [29] = {.lex_state = 1},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 1},
  [32] = {.lex_state = 6},
  [33] = {.lex_state = 6},
  [34] = {.lex_state = 1},
  [35] = {.lex_state = 6},
  [36] = {.lex_state = 6},
  [37] = {.lex_state = 6},
  [38] = {.lex_state = 6},
  [39] = {.lex_state = 6},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 6},
  [42] = {.lex_state = 6},
  [43] = {.lex_state = 6},
  [44] = {.lex_state = 6},
  [45] = {.lex_state = 6},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 6},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 6},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 6},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 6},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 6},
  [72] = {.lex_state = 6},
  [73] = {.lex_state = 1},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 6},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 6},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 1},
  [83] = {.lex_state = 6},
  [84] = {.lex_state = 6},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 6},
  [87] = {.lex_state = 6},
  [88] = {.lex_state = 6},
  [89] = {.lex_state = 6},
  [90] = {.lex_state = 6},
  [91] = {.lex_state = 6},
  [92] = {.lex_state = 6},
  [93] = {.lex_state = 6},
  [94] = {.lex_state = 6},
  [95] = {.lex_state = 6},
  [96] = {.lex_state = 6},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 6},
  [104] = {.lex_state = 6},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 1},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 1},
  [119] = {.lex_state = 2},
  [120] = {.lex_state = 6},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 6},
  [123] = {.lex_state = 6},
  [124] = {.lex_state = 6},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 6},
  [127] = {.lex_state = 1},
  [128] = {.lex_state = 1},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 1},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 6},
  [134] = {.lex_state = 6},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 6},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 6},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 6},
  [143] = {.lex_state = 6},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 6},
  [156] = {.lex_state = 1},
  [157] = {.lex_state = 1},
  [158] = {.lex_state = 6},
  [159] = {.lex_state = 6},
  [160] = {.lex_state = 6},
  [161] = {.lex_state = 6},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 20},
  [164] = {.lex_state = 6},
  [165] = {.lex_state = 6},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 1},
  [169] = {.lex_state = 6},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 6},
  [172] = {.lex_state = 6},
  [173] = {.lex_state = 6},
  [174] = {.lex_state = 6},
  [175] = {.lex_state = 1},
  [176] = {.lex_state = 6},
  [177] = {.lex_state = 6},
  [178] = {.lex_state = 6},
  [179] = {.lex_state = 6},
  [180] = {.lex_state = 6},
  [181] = {.lex_state = 1},
  [182] = {.lex_state = 6},
  [183] = {.lex_state = 1},
  [184] = {.lex_state = 1},
  [185] = {.lex_state = 1},
  [186] = {.lex_state = 1},
  [187] = {.lex_state = 6},
  [188] = {.lex_state = 6},
  [189] = {.lex_state = 6},
  [190] = {.lex_state = 6},
  [191] = {.lex_state = 6},
  [192] = {.lex_state = 6},
  [193] = {.lex_state = 6},
  [194] = {.lex_state = 6},
  [195] = {.lex_state = 6},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 6},
  [198] = {.lex_state = 6},
  [199] = {.lex_state = 6},
  [200] = {.lex_state = 6},
  [201] = {.lex_state = 6},
  [202] = {.lex_state = 6},
  [203] = {.lex_state = 6},
  [204] = {.lex_state = 1},
  [205] = {.lex_state = 6},
  [206] = {.lex_state = 6},
  [207] = {.lex_state = 6},
  [208] = {.lex_state = 6},
  [209] = {.lex_state = 6},
  [210] = {.lex_state = 6},
  [211] = {.lex_state = 6},
  [212] = {.lex_state = 6},
  [213] = {.lex_state = 1},
  [214] = {.lex_state = 6},
  [215] = {.lex_state = 6},
  [216] = {.lex_state = 6},
  [217] = {.lex_state = 6},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 6},
  [220] = {.lex_state = 6},
  [221] = {.lex_state = 6},
  [222] = {.lex_state = 6},
  [223] = {.lex_state = 6},
  [224] = {.lex_state = 6},
  [225] = {.lex_state = 6},
  [226] = {.lex_state = 6},
  [227] = {.lex_state = 6},
  [228] = {.lex_state = 6},
  [229] = {.lex_state = 6},
  [230] = {.lex_state = 6},
  [231] = {.lex_state = 6},
  [232] = {.lex_state = 6},
  [233] = {.lex_state = 6},
  [234] = {.lex_state = 6},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 6},
  [237] = {.lex_state = 6},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 6},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 6},
  [242] = {.lex_state = 6},
  [243] = {.lex_state = 6},
  [244] = {.lex_state = 6},
  [245] = {.lex_state = 6},
  [246] = {.lex_state = 6},
  [247] = {.lex_state = 6},
  [248] = {.lex_state = 6},
  [249] = {.lex_state = 6},
  [250] = {.lex_state = 6},
  [251] = {.lex_state = 6},
  [252] = {.lex_state = 6},
  [253] = {.lex_state = 6},
  [254] = {.lex_state = 6},
  [255] = {.lex_state = 6},
  [256] = {.lex_state = 6},
  [257] = {.lex_state = 6},
  [258] = {.lex_state = 6},
  [259] = {.lex_state = 6},
  [260] = {.lex_state = 6},
  [261] = {.lex_state = 6},
  [262] = {.lex_state = 6},
  [263] = {.lex_state = 6},
  [264] = {.lex_state = 6},
  [265] = {.lex_state = 6},
  [266] = {.lex_state = 6},
  [267] = {.lex_state = 6},
  [268] = {.lex_state = 6},
  [269] = {.lex_state = 6},
  [270] = {.lex_state = 6},
  [271] = {.lex_state = 6},
  [272] = {.lex_state = 6},
  [273] = {.lex_state = 6},
  [274] = {.lex_state = 6},
  [275] = {.lex_state = 6},
  [276] = {.lex_state = 6},
  [277] = {.lex_state = 6},
  [278] = {.lex_state = 6},
  [279] = {.lex_state = 6},
  [280] = {.lex_state = 6},
  [281] = {.lex_state = 6},
  [282] = {.lex_state = 6},
  [283] = {.lex_state = 6},
  [284] = {.lex_state = 6},
  [285] = {.lex_state = 6},
  [286] = {.lex_state = 6},
  [287] = {.lex_state = 6},
  [288] = {.lex_state = 6},
  [289] = {.lex_state = 6},
  [290] = {.lex_state = 6},
  [291] = {.lex_state = 6},
  [292] = {.lex_state = 6},
  [293] = {.lex_state = 6},
  [294] = {.lex_state = 6},
  [295] = {.lex_state = 6},
  [296] = {.lex_state = 6},
  [297] = {.lex_state = 6},
  [298] = {.lex_state = 6},
  [299] = {.lex_state = 6},
  [300] = {.lex_state = 6},
  [301] = {.lex_state = 6},
  [302] = {.lex_state = 6},
  [303] = {.lex_state = 6},
  [304] = {.lex_state = 6},
  [305] = {.lex_state = 6},
  [306] = {.lex_state = 6},
  [307] = {.lex_state = 6},
  [308] = {.lex_state = 6},
  [309] = {.lex_state = 6},
  [310] = {.lex_state = 6},
  [311] = {.lex_state = 6},
  [312] = {.lex_state = 6},
  [313] = {.lex_state = 6},
  [314] = {.lex_state = 6},
  [315] = {.lex_state = 6},
  [316] = {.lex_state = 6},
  [317] = {.lex_state = 6},
  [318] = {.lex_state = 6},
  [319] = {.lex_state = 6},
  [320] = {.lex_state = 6},
  [321] = {.lex_state = 6},
  [322] = {.lex_state = 6},
  [323] = {.lex_state = 6},
  [324] = {.lex_state = 6},
  [325] = {.lex_state = 6},
  [326] = {.lex_state = 1},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 6},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 6},
  [331] = {.lex_state = 6},
  [332] = {.lex_state = 6},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 6},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 6},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 6},
  [353] = {.lex_state = 6},
  [354] = {.lex_state = 6},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 6},
  [357] = {.lex_state = 6},
  [358] = {.lex_state = 6},
  [359] = {.lex_state = 6},
  [360] = {.lex_state = 6},
  [361] = {.lex_state = 6},
  [362] = {.lex_state = 6},
  [363] = {.lex_state = 6},
  [364] = {.lex_state = 6},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 6},
  [367] = {.lex_state = 6},
  [368] = {.lex_state = 6},
  [369] = {.lex_state = 6},
  [370] = {.lex_state = 6},
  [371] = {.lex_state = 1},
  [372] = {.lex_state = 6},
  [373] = {.lex_state = 9},
  [374] = {.lex_state = 6},
  [375] = {.lex_state = 6},
  [376] = {.lex_state = 6},
  [377] = {.lex_state = 6},
  [378] = {.lex_state = 6},
  [379] = {.lex_state = 6},
  [380] = {.lex_state = 6},
  [381] = {.lex_state = 6},
  [382] = {.lex_state = 6},
  [383] = {.lex_state = 6},
  [384] = {.lex_state = 6},
  [385] = {.lex_state = 6},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 2},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 2},
  [424] = {.lex_state = 2},
  [425] = {.lex_state = 9},
  [426] = {.lex_state = 22},
  [427] = {.lex_state = 20},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 2},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 2},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 1},
  [437] = {.lex_state = 22},
  [438] = {.lex_state = 22},
  [439] = {.lex_state = 22},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 22},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 6},
  [451] = {.lex_state = 6},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 6},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 6},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 22},
  [462] = {.lex_state = 1},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 6},
  [465] = {.lex_state = 6},
  [466] = {.lex_state = 6},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 6},
  [470] = {.lex_state = 6},
  [471] = {.lex_state = 6},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 6},
  [475] = {.lex_state = 6},
  [476] = {.lex_state = 2},
  [477] = {.lex_state = 6},
  [478] = {.lex_state = 6},
  [479] = {.lex_state = 6},
  [480] = {.lex_state = 6},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 6},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 6},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 6},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 6},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 6},
  [504] = {.lex_state = 6},
  [505] = {.lex_state = 6},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 6},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 0},
  [511] = {.lex_state = 6},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 6},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 0},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 0},
  [523] = {.lex_state = 1},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 1},
  [528] = {.lex_state = 6},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 6},
  [531] = {.lex_state = 6},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 6},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 6},
  [537] = {.lex_state = 6},
  [538] = {.lex_state = 6},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 6},
  [541] = {.lex_state = 6},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 6},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 6},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 118},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 118},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_version] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [sym_controlled_language_tag] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_reserved_self] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_Thing] = ACTIONS(1),
    [anon_sym_Nothing] = ACTIONS(1),
    [anon_sym_real] = ACTIONS(1),
    [anon_sym_rational] = ACTIONS(1),
    [anon_sym_anyURI] = ACTIONS(1),
    [anon_sym_iri] = ACTIONS(1),
    [anon_sym_base64Binary] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_date] = ACTIONS(1),
    [anon_sym_dateTime] = ACTIONS(1),
    [anon_sym_decimal] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_duration] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_gDay] = ACTIONS(1),
    [anon_sym_gMonth] = ACTIONS(1),
    [anon_sym_gMonthDay] = ACTIONS(1),
    [anon_sym_gYearMonth] = ACTIONS(1),
    [anon_sym_gYear] = ACTIONS(1),
    [anon_sym_hexBinary] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_time] = ACTIONS(1),
    [anon_sym_dateTimeStamp] = ACTIONS(1),
    [anon_sym_dayTimeDuration] = ACTIONS(1),
    [anon_sym_yearMonthDuration] = ACTIONS(1),
    [anon_sym_integer] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_nonNegativeInteger] = ACTIONS(1),
    [anon_sym_positiveInteger] = ACTIONS(1),
    [anon_sym_unsignedLong] = ACTIONS(1),
    [anon_sym_unsignedInt] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_unsignedShort] = ACTIONS(1),
    [anon_sym_unsignedByte] = ACTIONS(1),
    [anon_sym_nonPositiveInteger] = ACTIONS(1),
    [anon_sym_negativeInteger] = ACTIONS(1),
    [anon_sym_normalizedString] = ACTIONS(1),
    [anon_sym_token] = ACTIONS(1),
    [anon_sym_language] = ACTIONS(1),
    [sym_quoted_string] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [sym_hex_byte] = ACTIONS(1),
    [sym_double] = ACTIONS(1),
    [sym_decimal] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_rational] = ACTIONS(1),
    [sym_unsigned] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_u22a4] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_u22a5] = ACTIONS(1),
    [anon_sym_datatype] = ACTIONS(1),
    [sym_opaque] = ACTIONS(1),
    [anon_sym_length] = ACTIONS(1),
    [anon_sym_maxLength] = ACTIONS(1),
    [anon_sym_minLength] = ACTIONS(1),
    [anon_sym_fractionDigits] = ACTIONS(1),
    [anon_sym_totalDigits] = ACTIONS(1),
    [anon_sym_maxExclusive] = ACTIONS(1),
    [anon_sym_maxInclusive] = ACTIONS(1),
    [anon_sym_minExclusive] = ACTIONS(1),
    [anon_sym_minInclusive] = ACTIONS(1),
    [anon_sym_explicitTimezone] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_prohibited] = ACTIONS(1),
    [anon_sym_optional] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [sym_kw_is_fixed] = ACTIONS(1),
    [anon_sym_dimension] = ACTIONS(1),
    [anon_sym_source] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [anon_sym_entity] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_structure] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_rdf] = ACTIONS(1),
    [anon_sym_a] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [sym_wildcard] = ACTIONS(1),
    [anon_sym_identity] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [sym_unknown_type] = ACTIONS(1),
    [anon_sym_ordered] = ACTIONS(1),
    [anon_sym_unordered] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_nonunique] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_u2260] = ACTIONS(1),
    [sym_op_less_than] = ACTIONS(1),
    [sym_op_greater_than] = ACTIONS(1),
    [anon_sym_u2264] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_u2265] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_u00ac] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_u2227] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_u2228] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_u22bb] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_EQ_EQ_GT] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_iff] = ACTIONS(1),
    [anon_sym_u21d4] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_u2203] = ACTIONS(1),
    [anon_sym_u222a] = ACTIONS(1),
    [anon_sym_intersection] = ACTIONS(1),
    [anon_sym_u2229] = ACTIONS(1),
    [anon_sym_subset] = ACTIONS(1),
    [anon_sym_u2282] = ACTIONS(1),
    [anon_sym_subseteq] = ACTIONS(1),
    [anon_sym_u2286] = ACTIONS(1),
    [anon_sym_complement] = ACTIONS(1),
    [anon_sym_u2216] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [sym_set_op_builder] = ACTIONS(1),
    [anon_sym_u00b7] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_u2254] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_u2295] = ACTIONS(1),
    [sym__value_empty_sequence] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_module] = STATE(555),
    [anon_sym_module] = ACTIONS(5),
    [sym_line_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(9), 55,
      anon_sym_version,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [69] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(11), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(13), 54,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [137] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(25), 1,
      sym_unknown_type,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(17), 1,
      sym_cardinality_expression,
    STATE(202), 1,
      sym_type_reference,
    STATE(179), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [221] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(31), 1,
      sym_language_tag,
    ACTIONS(27), 6,
      sym_identifier,
      anon_sym_AT,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(29), 51,
      anon_sym_is,
      anon_sym_end,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(33), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(35), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [354] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(39), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [419] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(43), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [484] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(47), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [549] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(49), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(51), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [614] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(53), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(55), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [679] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(57), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(59), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [744] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(18), 1,
      sym_function_cardinality_expression,
    STATE(312), 1,
      sym_function_type_reference,
    STATE(319), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(63), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(65), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [890] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      sym_unknown_type,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(485), 1,
      sym_type_reference,
    STATE(179), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [968] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      sym_unknown_type,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(413), 1,
      sym_type_reference,
    STATE(179), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1046] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      sym_unknown_type,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(206), 1,
      sym_type_reference,
    STATE(179), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1124] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(331), 1,
      sym_function_type_reference,
    STATE(319), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1199] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(67), 1,
      sym_opaque,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(209), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1271] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(140), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(201), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(551), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1392] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(142), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(216), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(551), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1513] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(141), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(216), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(551), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1634] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(203), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(133), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(23), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(21), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1703] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(161), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1824] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(139), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(216), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(551), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1945] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(143), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2066] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(155), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2187] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(138), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2308] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(137), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2429] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(140), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(198), 1,
      sym_term,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(551), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2550] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(26), 1,
      sym_logical_op_negation,
    STATE(164), 1,
      sym_constraint_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_quantified_sentence,
    STATE(212), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(190), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(195), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2671] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(101), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(103), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2725] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(105), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(107), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2779] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(109), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(111), 42,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [2833] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(113), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(115), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2887] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(119), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2941] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(121), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(123), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [2994] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(125), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(127), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3047] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(129), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(131), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3100] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(133), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(135), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3153] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(137), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(139), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3206] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(141), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(143), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3259] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(145), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(147), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3312] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(149), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(151), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3365] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(153), 1,
      anon_sym_COLON,
    ACTIONS(39), 34,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [3411] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3456] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    ACTIONS(167), 1,
      sym_reserved_self,
    ACTIONS(169), 1,
      anon_sym_LBRACE,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    STATE(50), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(144), 1,
      sym_term,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(152), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(162), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3537] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(167), 1,
      sym_reserved_self,
    ACTIONS(169), 1,
      anon_sym_LBRACE,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(187), 1,
      anon_sym_RPAREN,
    STATE(51), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(144), 1,
      sym_term,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(152), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(162), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3618] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(167), 1,
      sym_reserved_self,
    ACTIONS(169), 1,
      anon_sym_LBRACE,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(189), 1,
      anon_sym_RPAREN,
    STATE(48), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(144), 1,
      sym_term,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(152), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(162), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3699] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(167), 1,
      sym_reserved_self,
    ACTIONS(169), 1,
      anon_sym_LBRACE,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(191), 1,
      anon_sym_RPAREN,
    STATE(51), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(144), 1,
      sym_term,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(152), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(162), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3780] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(193), 1,
      sym_identifier,
    ACTIONS(196), 1,
      anon_sym_LBRACK,
    ACTIONS(199), 1,
      anon_sym_RPAREN,
    ACTIONS(201), 1,
      sym_reserved_self,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(210), 1,
      anon_sym_LT,
    ACTIONS(213), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(228), 1,
      sym__value_empty_sequence,
    STATE(51), 1,
      aux_sym__actual_arguments_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(144), 1,
      sym_term,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(216), 2,
      sym_double,
      sym_rational,
    ACTIONS(222), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(225), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(152), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(219), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(162), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3861] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(231), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(233), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3903] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(235), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(237), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3945] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(239), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(241), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3987] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(243), 1,
      anon_sym_end,
    ACTIONS(245), 1,
      anon_sym_import,
    ACTIONS(247), 1,
      anon_sym_from,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    STATE(524), 1,
      sym_from_clause,
    STATE(83), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(177), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4067] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(273), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(275), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4109] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(245), 1,
      anon_sym_import,
    ACTIONS(247), 1,
      anon_sym_from,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    ACTIONS(277), 1,
      anon_sym_end,
    STATE(524), 1,
      sym_from_clause,
    STATE(55), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(84), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(120), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4189] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4231] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(279), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(281), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4273] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(283), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(285), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4315] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(287), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(289), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4357] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(291), 1,
      anon_sym_COLON,
    STATE(71), 1,
      aux_sym_function_composition_repeat1,
    STATE(544), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(37), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(39), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [4406] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(165), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4481] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(417), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4556] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(159), 1,
      sym_term,
    STATE(463), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(94), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(92), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4631] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(297), 1,
      anon_sym_RBRACK,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    STATE(78), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4709] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(67), 1,
      aux_sym_function_composition_repeat1,
    STATE(544), 1,
      sym__function_op_composition,
    ACTIONS(305), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(303), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(301), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [4755] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(308), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4833] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(310), 1,
      anon_sym_RBRACK,
    STATE(78), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4911] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_RBRACK,
    STATE(78), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4989] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(67), 1,
      aux_sym_function_composition_repeat1,
    STATE(544), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(316), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(314), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5035] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(67), 1,
      aux_sym_function_composition_repeat1,
    STATE(544), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(316), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(314), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5081] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(318), 1,
      anon_sym_RBRACK,
    STATE(69), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5159] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(320), 1,
      anon_sym_RBRACK,
    STATE(78), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5237] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(322), 1,
      anon_sym_RBRACK,
    STATE(66), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5315] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(185), 1,
      sym__value_empty_sequence,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      anon_sym_RBRACK,
    STATE(70), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5393] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(72), 1,
      aux_sym_function_composition_repeat1,
    STATE(544), 1,
      sym__function_op_composition,
    ACTIONS(293), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(328), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(326), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5439] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(330), 1,
      sym_identifier,
    ACTIONS(333), 1,
      anon_sym_LBRACK,
    ACTIONS(336), 1,
      anon_sym_RBRACK,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      sym_quoted_string,
    ACTIONS(344), 1,
      anon_sym_LT,
    ACTIONS(347), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(362), 1,
      sym__value_empty_sequence,
    STATE(78), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(150), 1,
      sym_simple_value,
    STATE(152), 1,
      sym_sequence_of_predicate_values,
    STATE(175), 1,
      sym_identifier_reference,
    STATE(454), 1,
      sym__sequence_value_constraints,
    ACTIONS(350), 2,
      sym_double,
      sym_rational,
    ACTIONS(356), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(359), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(353), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(184), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5517] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(136), 1,
      sym_simple_value,
    STATE(171), 1,
      sym_value,
    STATE(468), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(58), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5589] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(369), 26,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u00b7,
      anon_sym_DOT,
  [5627] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(52), 1,
      sym_value,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(147), 1,
      sym_simple_value,
    STATE(468), 1,
      sym__sequence_value_constraints,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(58), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5699] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_LBRACK,
    ACTIONS(367), 1,
      sym__value_empty_sequence,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(52), 1,
      sym_value,
    STATE(136), 1,
      sym_simple_value,
    STATE(468), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(58), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5771] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    ACTIONS(373), 1,
      anon_sym_end,
    STATE(123), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5838] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(243), 1,
      anon_sym_end,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    STATE(122), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5905] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(377), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(375), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5941] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(381), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(379), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5977] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(385), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(383), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6013] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(389), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(387), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6049] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(393), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(391), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6085] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(397), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(395), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6121] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(401), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(399), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6157] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(328), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(326), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6193] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(405), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(403), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6229] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(407), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6265] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(413), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(411), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6301] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 8,
      anon_sym_is,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6338] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(421), 1,
      anon_sym_RBRACK,
    STATE(98), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(181), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(213), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6400] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(423), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(181), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(213), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6462] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(425), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(181), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(213), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6524] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(430), 1,
      anon_sym_RBRACK,
    ACTIONS(432), 1,
      sym_quoted_string,
    ACTIONS(435), 1,
      anon_sym_LT,
    ACTIONS(438), 1,
      anon_sym_POUND_LBRACK,
    STATE(100), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(181), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(441), 2,
      sym_double,
      sym_rational,
    ACTIONS(447), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(450), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(213), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(444), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6586] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(171), 1,
      sym_quoted_string,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(175), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(295), 1,
      sym_identifier,
    ACTIONS(453), 1,
      anon_sym_RBRACK,
    STATE(99), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(181), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(177), 2,
      sym_double,
      sym_rational,
    ACTIONS(181), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(183), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(131), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(213), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(132), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6648] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(455), 1,
      sym_kw_is_fixed,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(234), 1,
      sym_restriction_value,
    STATE(514), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(228), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6707] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 6,
      anon_sym_LPAREN,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6742] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(415), 9,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(417), 12,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6777] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(457), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(459), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6809] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(461), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(463), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6841] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(233), 1,
      sym_restriction_value,
    STATE(514), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(228), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6897] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(465), 1,
      anon_sym_COLON,
    STATE(118), 1,
      aux_sym_function_composition_repeat1,
    STATE(537), 1,
      sym__function_op_composition,
    ACTIONS(467), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(37), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(39), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [6937] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(469), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(471), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6969] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(473), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(475), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7001] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(477), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(479), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7033] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(481), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(483), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [7065] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(39), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7096] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(114), 1,
      aux_sym_function_composition_repeat1,
    STATE(537), 1,
      sym__function_op_composition,
    ACTIONS(485), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(303), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(301), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7133] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(121), 1,
      aux_sym_function_composition_repeat1,
    STATE(537), 1,
      sym__function_op_composition,
    ACTIONS(467), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(328), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(326), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7170] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(11), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(13), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7201] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(9), 19,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7232] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(114), 1,
      aux_sym_function_composition_repeat1,
    STATE(537), 1,
      sym__function_op_composition,
    ACTIONS(467), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(316), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(314), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7269] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(488), 1,
      sym_language_tag,
    ACTIONS(27), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(29), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7302] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(243), 1,
      anon_sym_end,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7355] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(114), 1,
      aux_sym_function_composition_repeat1,
    STATE(537), 1,
      sym__function_op_composition,
    ACTIONS(467), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(316), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(314), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7392] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    ACTIONS(373), 1,
      anon_sym_end,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7445] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(253), 1,
      anon_sym_datatype,
    ACTIONS(255), 1,
      anon_sym_dimension,
    ACTIONS(257), 1,
      anon_sym_entity,
    ACTIONS(259), 1,
      anon_sym_enum,
    ACTIONS(261), 1,
      anon_sym_event,
    ACTIONS(263), 1,
      anon_sym_property,
    ACTIONS(265), 1,
      anon_sym_structure,
    ACTIONS(267), 1,
      anon_sym_union,
    ACTIONS(269), 1,
      anon_sym_rdf,
    ACTIONS(271), 1,
      anon_sym_class,
    ACTIONS(490), 1,
      anon_sym_end,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7498] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(492), 1,
      anon_sym_end,
    ACTIONS(494), 1,
      anon_sym_datatype,
    ACTIONS(497), 1,
      anon_sym_dimension,
    ACTIONS(500), 1,
      anon_sym_entity,
    ACTIONS(503), 1,
      anon_sym_enum,
    ACTIONS(506), 1,
      anon_sym_event,
    ACTIONS(509), 1,
      anon_sym_property,
    ACTIONS(512), 1,
      anon_sym_structure,
    ACTIONS(515), 1,
      anon_sym_union,
    ACTIONS(518), 1,
      anon_sym_rdf,
    ACTIONS(521), 1,
      anon_sym_class,
    STATE(124), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(255), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7551] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(57), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(59), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7581] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(528), 1,
      anon_sym_AT,
    ACTIONS(531), 1,
      anon_sym_assert,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    ACTIONS(526), 15,
      anon_sym_end,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [7619] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(49), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(51), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(63), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(65), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7679] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(33), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(35), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7709] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(47), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7739] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(43), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7769] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(53), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(55), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7799] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(536), 21,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7829] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(538), 1,
      sym_identifier,
    ACTIONS(540), 20,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7858] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(369), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u00b7,
      anon_sym_DOT,
      sym__value_empty_sequence,
  [7887] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(155), 1,
      sym_identifier,
    STATE(82), 1,
      sym__type_op_has_type,
    ACTIONS(542), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(157), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [7920] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(544), 3,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [7959] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(556), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [7988] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(544), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(22), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8027] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    ACTIONS(558), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(22), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8066] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(22), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(556), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8095] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(22), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(560), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8124] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(560), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8153] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    STATE(170), 1,
      sym__actual_arguments,
    ACTIONS(562), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(564), 14,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8185] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(377), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(375), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(397), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(395), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8241] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(81), 1,
      sym__type_op_has_type,
    ACTIONS(568), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(155), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(157), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8273] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(401), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(399), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8301] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(291), 1,
      anon_sym_COLON,
    ACTIONS(572), 1,
      anon_sym_as,
    STATE(194), 1,
      sym_iri,
    STATE(197), 1,
      sym__rename_import,
    ACTIONS(570), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [8337] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(81), 1,
      sym__type_op_has_type,
    ACTIONS(568), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(409), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(407), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8369] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(413), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(411), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8397] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(407), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8425] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(405), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(403), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8453] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(385), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(383), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8481] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(574), 1,
      anon_sym_RPAREN,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8518] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(381), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(379), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8545] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(507), 1,
      sym_simple_value,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(8), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [8588] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(576), 1,
      anon_sym_RBRACE,
    ACTIONS(584), 1,
      anon_sym_explicitTimezone,
    ACTIONS(586), 1,
      anon_sym_pattern,
    ACTIONS(580), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(578), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(582), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(169), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8625] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym__actual_arguments,
    ACTIONS(588), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8654] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(415), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8679] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(592), 1,
      anon_sym_end,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8716] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(328), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(326), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8743] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(598), 1,
      sym_controlled_language_tag,
    ACTIONS(594), 2,
      sym_identifier,
      anon_sym_AT,
    ACTIONS(596), 16,
      anon_sym_end,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8772] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(600), 1,
      anon_sym_end,
    ACTIONS(546), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(548), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(550), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(552), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(554), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(28), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8809] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym__actual_arguments,
    ACTIONS(602), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8838] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(465), 1,
      anon_sym_COLON,
    ACTIONS(37), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(39), 14,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8867] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(393), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(391), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8894] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(389), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(387), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8921] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(604), 1,
      anon_sym_RBRACE,
    ACTIONS(615), 1,
      anon_sym_explicitTimezone,
    ACTIONS(618), 1,
      anon_sym_pattern,
    ACTIONS(609), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(606), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(612), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(169), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8958] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(415), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8985] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(621), 1,
      sym_identifier,
    ACTIONS(623), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9011] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(625), 1,
      sym_identifier,
    ACTIONS(627), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9037] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(629), 1,
      sym_identifier,
    ACTIONS(631), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9063] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(635), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9089] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(637), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(639), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9117] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(641), 1,
      sym_identifier,
    ACTIONS(643), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9143] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(647), 1,
      anon_sym_import,
    ACTIONS(650), 1,
      anon_sym_from,
    STATE(524), 1,
      sym_from_clause,
    STATE(177), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    ACTIONS(645), 13,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9175] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(584), 1,
      anon_sym_explicitTimezone,
    ACTIONS(586), 1,
      anon_sym_pattern,
    ACTIONS(580), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(578), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(582), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(158), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [9209] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(653), 1,
      sym_identifier,
    ACTIONS(655), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [9235] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(657), 1,
      sym_identifier,
    ACTIONS(659), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9261] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(81), 1,
      sym__type_op_has_type,
    ACTIONS(568), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(661), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(663), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(665), 1,
      sym_identifier,
    ACTIONS(667), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9315] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(669), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(671), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9340] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(637), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(639), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9365] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(673), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(675), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9390] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(677), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(679), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9415] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(572), 1,
      anon_sym_as,
    STATE(192), 1,
      sym__rename_import,
    ACTIONS(681), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9442] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(683), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9465] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(683), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9488] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(685), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9511] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(687), 1,
      sym_identifier,
    ACTIONS(689), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9536] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(691), 1,
      sym_identifier,
    ACTIONS(693), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9561] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(695), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9584] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(572), 1,
      anon_sym_as,
    STATE(182), 1,
      sym__rename_import,
    ACTIONS(697), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9611] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(699), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9634] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(701), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(703), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9659] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(705), 1,
      sym_identifier,
    ACTIONS(707), 16,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9684] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      anon_sym_EQ,
    STATE(104), 1,
      sym__actual_arguments,
    ACTIONS(711), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(713), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(715), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(717), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(558), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(65), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9723] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(683), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9746] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(719), 1,
      sym_identifier,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(215), 1,
      sym_annotation_only_body,
    ACTIONS(723), 13,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9774] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      anon_sym_EQ,
    STATE(96), 1,
      sym__actual_arguments,
    ACTIONS(558), 2,
      anon_sym_is,
      anon_sym_def,
    ACTIONS(711), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(713), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(715), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(717), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(65), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9812] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(725), 1,
      sym_identifier,
    ACTIONS(727), 14,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9835] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(731), 1,
      anon_sym_LBRACE,
    STATE(224), 1,
      sym_datatype_def_restriction,
    STATE(263), 1,
      sym_annotation_only_body,
    ACTIONS(729), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9864] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(661), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(663), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9889] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(733), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9910] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(735), 1,
      sym_identifier,
    ACTIONS(737), 14,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9933] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(739), 1,
      sym_identifier,
    ACTIONS(741), 14,
      anon_sym_end,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9956] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(743), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9977] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(731), 1,
      anon_sym_LBRACE,
    STATE(226), 1,
      sym_datatype_def_restriction,
    STATE(261), 1,
      sym_annotation_only_body,
    ACTIONS(745), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10006] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(747), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10027] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(749), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_from,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10048] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      anon_sym_EQ,
    STATE(96), 1,
      sym__actual_arguments,
    ACTIONS(711), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(713), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(715), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(717), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(65), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [10082] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(661), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(663), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [10104] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(751), 1,
      anon_sym_is,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    STATE(271), 1,
      sym_type_class_body,
    ACTIONS(753), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10130] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(757), 1,
      sym_identifier,
    ACTIONS(759), 13,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [10152] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      anon_sym_EQ,
    STATE(103), 1,
      sym__actual_arguments,
    ACTIONS(711), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(713), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(715), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(717), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(65), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [10186] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(761), 1,
      anon_sym_is,
    STATE(257), 1,
      sym_event_body,
    ACTIONS(763), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10209] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(765), 1,
      anon_sym_is,
    STATE(248), 1,
      sym_dimension_body,
    ACTIONS(767), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10232] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(751), 1,
      anon_sym_is,
    STATE(279), 1,
      sym_type_class_body,
    ACTIONS(769), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10255] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(773), 1,
      anon_sym_end,
    ACTIONS(775), 1,
      anon_sym_ref,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(335), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [10290] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(777), 1,
      anon_sym_is,
    STATE(246), 1,
      sym_entity_body,
    ACTIONS(779), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10313] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(781), 1,
      anon_sym_end,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(220), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(309), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [10348] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(785), 1,
      anon_sym_of,
    STATE(262), 1,
      sym_union_body,
    ACTIONS(783), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10371] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(287), 1,
      sym_annotation_only_body,
    ACTIONS(787), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10394] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(791), 1,
      anon_sym_of,
    STATE(274), 1,
      sym_enum_body,
    ACTIONS(789), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10417] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(256), 1,
      sym_annotation_only_body,
    ACTIONS(793), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10440] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(795), 1,
      anon_sym_is,
    STATE(260), 1,
      sym_structure_body,
    ACTIONS(797), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10463] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(799), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10481] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(801), 1,
      sym_identifier,
    ACTIONS(803), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(378), 1,
      sym_identifier_reference,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(237), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(346), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10515] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(805), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10533] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(807), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10551] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(809), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10569] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(811), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10587] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(813), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10605] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(815), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10623] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(817), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10641] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(801), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(378), 1,
      sym_identifier_reference,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(350), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10675] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(821), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10693] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(823), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10711] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(825), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10729] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(827), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10747] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(829), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10765] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(831), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10782] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(833), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10799] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(835), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10816] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(837), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10833] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(839), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10850] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(841), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10867] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(843), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10884] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(845), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10901] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(847), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10918] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(849), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10935] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(851), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10952] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(853), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10969] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(855), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10986] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(857), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11003] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(859), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11020] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(861), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11037] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(863), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11054] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(865), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11071] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(867), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11088] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(869), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11105] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(871), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11122] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(873), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11139] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(875), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11156] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(877), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11173] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(879), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11190] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(881), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11207] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(883), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11224] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(885), 1,
      anon_sym_end,
    ACTIONS(887), 1,
      anon_sym_def,
    STATE(301), 1,
      sym_function_signature,
    STATE(377), 1,
      aux_sym_type_class_body_repeat1,
    STATE(475), 1,
      sym_method_def,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(282), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11257] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(889), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11274] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(891), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11291] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(893), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11308] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(895), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11325] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(897), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11342] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(899), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11359] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(901), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11376] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(903), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11393] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(905), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11410] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(907), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11427] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(909), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11444] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(887), 1,
      anon_sym_def,
    ACTIONS(911), 1,
      anon_sym_end,
    STATE(301), 1,
      sym_function_signature,
    STATE(372), 1,
      aux_sym_type_class_body_repeat1,
    STATE(475), 1,
      sym_method_def,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
  [11477] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(913), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11494] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(915), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11511] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(917), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11528] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(919), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11545] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(921), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11562] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(923), 1,
      anon_sym_end,
    ACTIONS(925), 1,
      anon_sym_parent,
    STATE(292), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(318), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [11590] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(925), 1,
      anon_sym_parent,
    ACTIONS(927), 1,
      anon_sym_end,
    STATE(321), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(353), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [11618] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(925), 1,
      anon_sym_parent,
    ACTIONS(929), 1,
      anon_sym_end,
    STATE(289), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(328), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [11646] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(931), 1,
      anon_sym_source,
    ACTIONS(933), 1,
      anon_sym_identity,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(290), 2,
      sym_source_entity,
      sym_entity_identity,
    STATE(295), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11674] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(925), 1,
      anon_sym_parent,
    ACTIONS(935), 1,
      anon_sym_end,
    STATE(322), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(353), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [11702] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(937), 1,
      sym_identifier,
    ACTIONS(939), 1,
      anon_sym_end,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(390), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [11730] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(937), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_end,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(293), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(394), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [11758] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(931), 1,
      anon_sym_source,
    ACTIONS(933), 1,
      anon_sym_identity,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(288), 2,
      sym_source_entity,
      sym_entity_identity,
  [11786] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(943), 1,
      sym_identifier,
    STATE(380), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(402), 1,
      sym_sequence_ordering,
    STATE(448), 1,
      sym_variable,
    STATE(513), 1,
      sym_sequence_uniqueness,
    ACTIONS(945), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11813] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(494), 1,
      sym_sequence_builder_body,
    STATE(496), 1,
      sym_quantified_sentence,
    STATE(509), 1,
      sym_quantified_variable_binding,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [11838] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(949), 1,
      anon_sym_RBRACE,
    ACTIONS(951), 1,
      sym_unsigned,
    STATE(344), 1,
      sym_sequence_ordering,
    STATE(431), 1,
      sym_sequence_uniqueness,
    STATE(512), 1,
      sym__cardinality_inner,
    ACTIONS(945), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11865] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(943), 1,
      sym_identifier,
    STATE(386), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(402), 1,
      sym_sequence_ordering,
    STATE(448), 1,
      sym_variable,
    STATE(513), 1,
      sym_sequence_uniqueness,
    ACTIONS(945), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11892] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(496), 1,
      sym_quantified_sentence,
    STATE(509), 1,
      sym_quantified_variable_binding,
    STATE(548), 1,
      sym_sequence_builder_body,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(445), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [11917] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(30), 1,
      sym__function_op_by_definition,
    STATE(408), 1,
      sym_function_body,
    STATE(474), 1,
      sym_annotation_only_body,
    ACTIONS(953), 2,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(955), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [11941] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    STATE(376), 1,
      sym_sequence_ordering,
    STATE(477), 1,
      sym_sequence_uniqueness,
    STATE(487), 1,
      sym__cardinality_inner,
    ACTIONS(945), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11965] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(931), 1,
      anon_sym_source,
    STATE(307), 1,
      sym_source_entity,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
  [11989] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(931), 1,
      anon_sym_source,
    STATE(324), 1,
      sym_source_entity,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(303), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12013] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(933), 1,
      anon_sym_identity,
    STATE(327), 1,
      sym_entity_identity,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(306), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12037] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(933), 1,
      anon_sym_identity,
    STATE(330), 1,
      sym_entity_identity,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
  [12061] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(957), 1,
      anon_sym_end,
    STATE(313), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12082] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(308), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(387), 1,
      sym_type_op_combiner,
    ACTIONS(961), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(959), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12101] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(773), 1,
      anon_sym_end,
    ACTIONS(775), 1,
      anon_sym_ref,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12122] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(389), 1,
      sym__type_op_has_type,
    STATE(418), 1,
      sym_type_variable_restriction,
    ACTIONS(966), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(964), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12141] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(389), 1,
      sym__type_op_has_type,
    STATE(441), 1,
      sym_type_variable_restriction,
    ACTIONS(966), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(968), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12160] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(970), 1,
      sym_identifier,
    ACTIONS(972), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12175] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(974), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12196] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(976), 1,
      sym_identifier,
    STATE(414), 1,
      sym__type_op_has_type,
    ACTIONS(980), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(978), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [12215] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(325), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(387), 1,
      sym_type_op_combiner,
    ACTIONS(984), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(982), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12234] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(986), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12255] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(990), 1,
      anon_sym_LPAREN,
    STATE(364), 1,
      sym_type_class_arguments,
    ACTIONS(988), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [12272] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(935), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12293] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(992), 1,
      sym_identifier,
    ACTIONS(994), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12308] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(996), 1,
      sym_identifier,
    ACTIONS(998), 1,
      anon_sym_RBRACK,
    STATE(410), 1,
      sym_qualified_identifier,
    STATE(333), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12327] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1000), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12348] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1002), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12369] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(996), 1,
      sym_identifier,
    ACTIONS(1004), 1,
      anon_sym_RBRACK,
    STATE(410), 1,
      sym_qualified_identifier,
    STATE(333), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12388] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1006), 1,
      anon_sym_end,
    STATE(332), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12409] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(308), 1,
      aux_sym_type_variable_restriction_repeat1,
    STATE(387), 1,
      sym_type_op_combiner,
    ACTIONS(984), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1008), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12428] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(173), 1,
      anon_sym_LT,
    ACTIONS(465), 1,
      anon_sym_COLON,
    ACTIONS(570), 1,
      anon_sym_RBRACK,
    ACTIONS(1010), 1,
      sym_identifier,
    ACTIONS(1012), 1,
      anon_sym_as,
    STATE(197), 1,
      sym__rename_import,
    STATE(407), 1,
      sym_iri,
  [12453] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1014), 1,
      anon_sym_end,
    STATE(329), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12474] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(927), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12495] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1016), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12516] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1018), 1,
      anon_sym_end,
    STATE(316), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12537] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1020), 1,
      sym_identifier,
    ACTIONS(1022), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12552] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1024), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12573] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1026), 1,
      sym_identifier,
    ACTIONS(1029), 1,
      anon_sym_RBRACK,
    STATE(410), 1,
      sym_qualified_identifier,
    STATE(333), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12592] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1031), 1,
      sym_identifier,
    ACTIONS(1034), 1,
      anon_sym_end,
    ACTIONS(1036), 1,
      anon_sym_ref,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12613] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    ACTIONS(1039), 1,
      anon_sym_end,
    STATE(334), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [12634] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    ACTIONS(1041), 1,
      anon_sym_end,
    STATE(126), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
  [12655] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(1043), 1,
      sym_identifier,
    STATE(409), 1,
      sym_annotation_only_body,
    ACTIONS(1045), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [12673] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(1047), 1,
      sym_identifier,
    ACTIONS(1049), 1,
      anon_sym_RPAREN,
    STATE(339), 1,
      aux_sym_type_class_def_repeat1,
    STATE(416), 1,
      sym_type_variable,
    STATE(493), 1,
      sym_function_cardinality_expression,
  [12695] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 1,
      sym_identifier,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    ACTIONS(1056), 1,
      anon_sym_LBRACE,
    STATE(339), 1,
      aux_sym_type_class_def_repeat1,
    STATE(416), 1,
      sym_type_variable,
    STATE(493), 1,
      sym_function_cardinality_expression,
  [12717] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_LBRACK,
    STATE(187), 1,
      sym_qualified_identifier,
    STATE(211), 3,
      sym__import,
      sym_member_import,
      sym_module_import,
  [12735] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(996), 1,
      sym_identifier,
    STATE(410), 1,
      sym_qualified_identifier,
    STATE(320), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12751] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(317), 1,
      sym_identifier_reference,
    STATE(349), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(472), 1,
      sym_type_class_reference,
  [12773] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(402), 1,
      sym_sequence_ordering,
    STATE(513), 1,
      sym_sequence_uniqueness,
    ACTIONS(945), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12791] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    ACTIONS(1067), 1,
      anon_sym_RBRACE,
    STATE(420), 1,
      sym_sequence_uniqueness,
    STATE(482), 1,
      sym__cardinality_inner,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12811] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1069), 1,
      anon_sym_is,
    ACTIONS(1071), 1,
      anon_sym_EQ,
    ACTIONS(1073), 1,
      anon_sym_with,
    STATE(499), 1,
      sym_constraint_environment,
    STATE(173), 2,
      sym_informal_constraint,
      sym_formal_constraint,
  [12831] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(801), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(378), 1,
      sym_identifier_reference,
    STATE(351), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12851] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1075), 1,
      anon_sym_LBRACK,
    STATE(187), 1,
      sym_qualified_identifier,
    STATE(210), 3,
      sym__import,
      sym_member_import,
      sym_module_import,
  [12869] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 1,
      anon_sym_AT,
    ACTIONS(251), 1,
      anon_sym_assert,
    STATE(176), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(336), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12887] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1077), 1,
      sym_identifier,
    ACTIONS(1080), 1,
      anon_sym_RPAREN,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(317), 1,
      sym_identifier_reference,
    STATE(349), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(472), 1,
      sym_type_class_reference,
  [12909] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(801), 1,
      sym_identifier,
    ACTIONS(1082), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(378), 1,
      sym_identifier_reference,
    STATE(351), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12929] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 1,
      sym_identifier,
    ACTIONS(1087), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_qualified_identifier,
    STATE(378), 1,
      sym_identifier_reference,
    STATE(351), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12949] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(996), 1,
      sym_identifier,
    STATE(410), 1,
      sym_qualified_identifier,
    STATE(323), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12965] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1093), 1,
      anon_sym_parent,
    ACTIONS(1091), 2,
      anon_sym_end,
      anon_sym_ref,
    STATE(353), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
  [12983] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1096), 1,
      sym_wildcard,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(317), 1,
      sym_identifier_reference,
    STATE(342), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(472), 1,
      sym_type_class_reference,
  [13005] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1098), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13016] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(267), 1,
      sym_annotation_only_body,
    STATE(471), 1,
      sym_rdf_types,
    ACTIONS(1100), 2,
      anon_sym_a,
      anon_sym_type,
  [13033] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 1,
      sym_kw_is_fixed,
    STATE(230), 1,
      sym_tz_restriction_value,
    ACTIONS(1102), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [13048] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1106), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13059] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(1047), 1,
      sym_identifier,
    STATE(338), 1,
      aux_sym_type_class_def_repeat1,
    STATE(416), 1,
      sym_type_variable,
    STATE(493), 1,
      sym_function_cardinality_expression,
  [13078] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 1,
      sym_identifier,
    ACTIONS(1111), 1,
      anon_sym_RBRACK,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(360), 1,
      aux_sym_rdf_types_repeat1,
    STATE(480), 1,
      sym_identifier_reference,
  [13097] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1113), 1,
      anon_sym_is,
    ACTIONS(1115), 1,
      anon_sym_def,
    STATE(388), 1,
      sym_function_signature,
    STATE(361), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [13114] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1118), 1,
      anon_sym_RBRACK,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(360), 1,
      aux_sym_rdf_types_repeat1,
    STATE(480), 1,
      sym_identifier_reference,
  [13133] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1124), 1,
      anon_sym_with,
    ACTIONS(1122), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13148] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1126), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13159] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 1,
      anon_sym_LPAREN,
    STATE(13), 1,
      sym__type_op_has_type,
    STATE(370), 1,
      sym__function_type,
    ACTIONS(1130), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13176] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13187] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(771), 1,
      sym_identifier,
    ACTIONS(775), 1,
      anon_sym_ref,
    STATE(382), 1,
      sym_member,
    STATE(383), 2,
      sym_member_def,
      sym_property_ref,
  [13204] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(465), 1,
      anon_sym_COLON,
    ACTIONS(39), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_as,
  [13219] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(887), 1,
      anon_sym_def,
    ACTIONS(1134), 1,
      anon_sym_is,
    STATE(388), 1,
      sym_function_signature,
    STATE(361), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [13236] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13247] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1138), 1,
      anon_sym_is,
    STATE(450), 1,
      sym__module_locations,
    STATE(451), 1,
      sym_iri,
    STATE(547), 1,
      sym_module_body,
  [13266] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(887), 1,
      anon_sym_def,
    ACTIONS(1140), 1,
      anon_sym_end,
    STATE(301), 1,
      sym_function_signature,
    STATE(379), 1,
      aux_sym_type_class_body_repeat1,
    STATE(475), 1,
      sym_method_def,
  [13285] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_COLON_COLON,
    STATE(517), 3,
      sym_module_path_root_only,
      sym_module_path_absolute,
      sym_module_path_relative,
  [13300] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(959), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13311] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1146), 1,
      anon_sym_RBRACK,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(362), 1,
      aux_sym_rdf_types_repeat1,
    STATE(480), 1,
      sym_identifier_reference,
  [13330] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    STATE(456), 1,
      sym_sequence_uniqueness,
    STATE(529), 1,
      sym__cardinality_inner,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [13347] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(887), 1,
      anon_sym_def,
    ACTIONS(1148), 1,
      anon_sym_end,
    STATE(301), 1,
      sym_function_signature,
    STATE(379), 1,
      aux_sym_type_class_body_repeat1,
    STATE(475), 1,
      sym_method_def,
  [13366] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(1150), 1,
      sym_identifier,
    ACTIONS(1152), 1,
      anon_sym_end,
    ACTIONS(1154), 1,
      anon_sym_as,
    STATE(479), 1,
      sym_annotation_only_body,
  [13385] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 1,
      anon_sym_end,
    ACTIONS(1158), 1,
      anon_sym_def,
    STATE(301), 1,
      sym_function_signature,
    STATE(379), 1,
      aux_sym_type_class_body_repeat1,
    STATE(475), 1,
      sym_method_def,
  [13404] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      sym_identifier,
    ACTIONS(1163), 1,
      sym_set_op_builder,
    STATE(411), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(448), 1,
      sym_variable,
  [13420] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1165), 1,
      sym_identifier,
    ACTIONS(1167), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [13432] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1169), 1,
      sym_identifier,
    ACTIONS(1171), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13444] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1173), 1,
      sym_identifier,
    ACTIONS(1175), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13456] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(236), 1,
      sym_tz_restriction_value,
    ACTIONS(1102), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [13468] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1180), 1,
      anon_sym_end,
    STATE(385), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13482] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      sym_identifier,
    ACTIONS(1182), 1,
      sym_set_op_builder,
    STATE(411), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(448), 1,
      sym_variable,
  [13498] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(317), 1,
      sym_identifier_reference,
    STATE(374), 1,
      sym_type_class_reference,
  [13514] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(20), 1,
      sym__function_op_by_definition,
    STATE(470), 1,
      sym_function_body,
    ACTIONS(1184), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13528] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(315), 1,
      sym_type_class_reference,
    STATE(317), 1,
      sym_identifier_reference,
  [13544] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(937), 1,
      sym_identifier,
    ACTIONS(1186), 1,
      anon_sym_end,
    STATE(385), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13558] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 1,
      sym_identifier,
    ACTIONS(1191), 1,
      anon_sym_RPAREN,
    STATE(391), 1,
      aux_sym_function_signature_repeat1,
    STATE(473), 1,
      sym_function_parameter,
  [13574] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(13), 1,
      sym__type_op_has_type,
    STATE(358), 1,
      sym__function_type,
    ACTIONS(1130), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13588] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(1193), 1,
      sym_identifier,
    ACTIONS(1195), 1,
      anon_sym_end,
    STATE(457), 1,
      sym_annotation_only_body,
  [13604] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(937), 1,
      sym_identifier,
    ACTIONS(939), 1,
      anon_sym_end,
    STATE(385), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13618] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      sym_identifier,
    ACTIONS(1199), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13630] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 1,
      sym_identifier,
    ACTIONS(1203), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13642] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(4), 1,
      sym__type_op_has_type,
    STATE(200), 1,
      sym__type_expression_to,
    ACTIONS(1205), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13656] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    ACTIONS(1207), 1,
      sym_identifier,
    ACTIONS(1209), 1,
      anon_sym_end,
    STATE(449), 1,
      sym_annotation_only_body,
  [13672] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13684] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 1,
      sym_identifier,
    ACTIONS(1217), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13696] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_RPAREN,
    STATE(391), 1,
      aux_sym_function_signature_repeat1,
    STATE(473), 1,
      sym_function_parameter,
  [13712] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 1,
      anon_sym_RBRACE,
    STATE(520), 1,
      sym_sequence_uniqueness,
    ACTIONS(947), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [13726] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(887), 1,
      anon_sym_def,
    STATE(388), 1,
      sym_function_signature,
    STATE(369), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [13740] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 4,
      anon_sym_RBRACE,
      sym_unsigned,
      anon_sym_unique,
      anon_sym_nonunique,
  [13750] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(491), 1,
      sym_identifier_reference,
  [13766] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(13), 1,
      sym__type_op_has_type,
    STATE(458), 1,
      sym__function_type,
    ACTIONS(1130), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13780] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(697), 1,
      anon_sym_RBRACK,
    ACTIONS(1012), 1,
      anon_sym_as,
    ACTIONS(1229), 1,
      sym_identifier,
    STATE(182), 1,
      sym__rename_import,
  [13796] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(464), 1,
      sym_annotation_only_body,
    ACTIONS(1231), 2,
      anon_sym_end,
      anon_sym_def,
  [13810] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 1,
      sym_identifier,
    ACTIONS(1235), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13822] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(681), 1,
      anon_sym_RBRACK,
    ACTIONS(1012), 1,
      anon_sym_as,
    ACTIONS(1237), 1,
      sym_identifier,
    STATE(192), 1,
      sym__rename_import,
  [13838] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      sym_set_op_builder,
    STATE(411), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(448), 1,
      sym_variable,
  [13854] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 1,
      anon_sym_RBRACK,
    ACTIONS(1246), 1,
      sym_quoted_string,
    STATE(412), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [13867] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(15), 1,
      sym__type_op_has_type,
    ACTIONS(1249), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13878] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(381), 1,
      sym_identifier_reference,
  [13891] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 1,
      sym_identifier,
    ACTIONS(1253), 1,
      anon_sym_LBRACK,
    STATE(395), 1,
      sym__identifier_or_sequence,
  [13904] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13913] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_COMMA,
    STATE(160), 1,
      sym__actual_arguments,
  [13926] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13935] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 1,
      sym_identifier,
    ACTIONS(1264), 1,
      anon_sym_RBRACK,
    STATE(419), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [13948] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    ACTIONS(1266), 1,
      anon_sym_RBRACE,
    STATE(532), 1,
      sym__cardinality_inner,
  [13961] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 1,
      anon_sym_import,
    ACTIONS(1270), 1,
      anon_sym_COLON_COLON2,
    STATE(432), 1,
      aux_sym_module_path_absolute_repeat1,
  [13974] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 1,
      anon_sym_RBRACK,
    ACTIONS(1274), 1,
      sym_quoted_string,
    STATE(412), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [13987] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1270), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1276), 1,
      anon_sym_import,
    STATE(424), 1,
      aux_sym_module_path_absolute_repeat1,
  [14000] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1270), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1278), 1,
      anon_sym_import,
    STATE(432), 1,
      aux_sym_module_path_absolute_repeat1,
  [14013] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 1,
      anon_sym_RBRACE,
    ACTIONS(1282), 1,
      anon_sym_DOT_DOT,
    STATE(535), 1,
      sym_cardinality_range,
  [14026] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 1,
      anon_sym_RBRACK,
    ACTIONS(1286), 1,
      sym_hex_byte,
    STATE(426), 1,
      aux_sym_binary_repeat1,
  [14039] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(19), 1,
      sym__type_op_type_restriction,
    ACTIONS(1289), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
  [14050] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(337), 1,
      sym_identifier_reference,
  [14063] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(363), 1,
      sym_identifier_reference,
  [14076] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(399), 1,
      sym_identifier_reference,
  [14089] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    STATE(497), 1,
      sym__cardinality_inner,
  [14102] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 1,
      anon_sym_import,
    ACTIONS(1295), 1,
      anon_sym_COLON_COLON2,
    STATE(432), 1,
      aux_sym_module_path_absolute_repeat1,
  [14115] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1298), 1,
      sym_identifier,
    ACTIONS(1300), 1,
      anon_sym_RBRACK,
    STATE(419), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [14128] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1270), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1302), 1,
      anon_sym_import,
    STATE(421), 1,
      aux_sym_module_path_absolute_repeat1,
  [14141] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 1,
      sym_identifier,
    STATE(401), 1,
      aux_sym_function_signature_repeat1,
    STATE(473), 1,
      sym_function_parameter,
  [14154] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1304), 1,
      sym_quoted_string,
    STATE(508), 1,
      sym_iri,
  [14167] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1306), 1,
      anon_sym_RBRACK,
    ACTIONS(1308), 1,
      sym_hex_byte,
    STATE(426), 1,
      aux_sym_binary_repeat1,
  [14180] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1308), 1,
      sym_hex_byte,
    ACTIONS(1310), 1,
      anon_sym_RBRACK,
    STATE(439), 1,
      aux_sym_binary_repeat1,
  [14193] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1308), 1,
      sym_hex_byte,
    ACTIONS(1312), 1,
      anon_sym_RBRACK,
    STATE(426), 1,
      aux_sym_binary_repeat1,
  [14206] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(7), 1,
      sym_qualified_identifier,
    STATE(516), 1,
      sym_identifier_reference,
  [14219] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1314), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [14228] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1308), 1,
      sym_hex_byte,
    ACTIONS(1316), 1,
      anon_sym_RBRACK,
    STATE(437), 1,
      aux_sym_binary_repeat1,
  [14241] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(64), 1,
      sym_set_op_membership,
    ACTIONS(1318), 2,
      anon_sym_in,
      anon_sym_u2208,
  [14252] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(428), 1,
      sym__type_op_has_type,
    ACTIONS(1320), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [14263] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      sym_identifier,
    STATE(443), 1,
      sym_variable,
    STATE(554), 1,
      sym_quantified_variable,
  [14276] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1322), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_quoted_string,
  [14286] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1326), 1,
      sym_unsigned,
    ACTIONS(1328), 1,
      sym_kw_is_fixed,
  [14296] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 2,
      sym_identifier,
      sym_set_op_builder,
  [14304] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1332), 1,
      sym_identifier,
    ACTIONS(1334), 1,
      anon_sym_end,
  [14314] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1138), 1,
      anon_sym_is,
    STATE(522), 1,
      sym_module_body,
  [14324] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1336), 1,
      anon_sym_version,
    ACTIONS(1338), 1,
      anon_sym_is,
  [14334] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1340), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [14342] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 1,
      anon_sym_RBRACE,
    ACTIONS(1344), 1,
      sym_unsigned,
  [14352] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1346), 1,
      anon_sym_LBRACK,
    ACTIONS(1348), 1,
      sym__value_empty_sequence,
  [14362] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1350), 1,
      sym_identifier,
    STATE(278), 1,
      sym_member_def,
  [14372] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    STATE(502), 1,
      sym__cardinality_inner,
  [14382] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1352), 1,
      sym_identifier,
    ACTIONS(1354), 1,
      anon_sym_end,
  [14392] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1356), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [14400] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1358), 1,
      sym_identifier,
    ACTIONS(1360), 1,
      anon_sym_import,
  [14410] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1362), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [14418] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1364), 2,
      anon_sym_RBRACK,
      sym_hex_byte,
  [14426] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    STATE(489), 1,
      sym_iri,
  [14436] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1366), 1,
      anon_sym_LBRACK,
    ACTIONS(1368), 1,
      sym__value_empty_sequence,
  [14446] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1370), 2,
      anon_sym_end,
      anon_sym_def,
  [14454] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1372), 2,
      anon_sym_RBRACE,
      sym_unsigned,
  [14462] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1374), 1,
      sym_unsigned,
    ACTIONS(1376), 1,
      sym_kw_is_fixed,
  [14472] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1378), 1,
      sym_quoted_string,
    STATE(422), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [14482] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1380), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      sym__value_empty_sequence,
  [14492] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1384), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [14500] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1386), 2,
      anon_sym_is,
      anon_sym_def,
  [14508] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(721), 1,
      anon_sym_is,
    STATE(285), 1,
      sym_annotation_only_body,
  [14518] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1388), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [14526] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1390), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [14534] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1392), 2,
      anon_sym_end,
      anon_sym_def,
  [14542] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1394), 2,
      anon_sym_end,
      anon_sym_def,
  [14550] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1396), 2,
      anon_sym_import,
      anon_sym_COLON_COLON2,
  [14558] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(951), 1,
      sym_unsigned,
    STATE(518), 1,
      sym__cardinality_inner,
  [14568] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1298), 1,
      sym_identifier,
    STATE(433), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [14578] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1398), 1,
      sym_identifier,
    ACTIONS(1400), 1,
      anon_sym_end,
  [14588] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1402), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [14596] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1404), 2,
      anon_sym_LBRACK,
      sym__value_empty_sequence,
  [14604] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1406), 1,
      anon_sym_RBRACE,
  [14611] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1408), 1,
      sym_identifier,
  [14618] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1410), 1,
      anon_sym_RPAREN,
  [14625] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1412), 1,
      anon_sym_RPAREN,
  [14632] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1414), 1,
      sym_identifier,
  [14639] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1416), 1,
      anon_sym_RBRACE,
  [14646] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1418), 1,
      anon_sym_EQ,
  [14653] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1420), 1,
      anon_sym_is,
  [14660] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1422), 1,
      ts_builtin_sym_end,
  [14667] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1424), 1,
      anon_sym_is,
  [14674] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1426), 1,
      sym_identifier,
  [14681] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1428), 1,
      sym_identifier,
  [14688] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1430), 1,
      anon_sym_RBRACE,
  [14695] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1432), 1,
      anon_sym_is,
  [14702] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1434), 1,
      anon_sym_RBRACE,
  [14709] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1436), 1,
      anon_sym_RBRACE,
  [14716] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1438), 1,
      ts_builtin_sym_end,
  [14723] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1440), 1,
      anon_sym_is,
  [14730] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1442), 1,
      anon_sym_RBRACE,
  [14737] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1444), 1,
      sym_quoted_string,
  [14744] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1446), 1,
      anon_sym_RBRACE,
  [14751] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1448), 1,
      sym_identifier,
  [14758] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1450), 1,
      sym_identifier,
  [14765] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1452), 1,
      sym_identifier,
  [14772] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1454), 1,
      sym_identifier,
  [14779] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
  [14786] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1458), 1,
      anon_sym_is,
  [14793] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1460), 1,
      anon_sym_COMMA,
  [14800] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1462), 1,
      ts_builtin_sym_end,
  [14807] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1464), 1,
      anon_sym_is,
  [14814] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1466), 1,
      anon_sym_RBRACE,
  [14821] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1468), 1,
      anon_sym_RBRACE,
  [14828] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
  [14835] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1470), 1,
      sym_unsigned,
  [14842] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1472), 1,
      anon_sym_EQ,
  [14849] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1474), 1,
      anon_sym_import,
  [14856] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1476), 1,
      anon_sym_RBRACE,
  [14863] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1478), 1,
      sym_identifier,
  [14870] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1480), 1,
      anon_sym_RBRACE,
  [14877] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1482), 1,
      sym_unsigned,
  [14884] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1484), 1,
      ts_builtin_sym_end,
  [14891] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1486), 1,
      anon_sym_GT,
  [14898] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1488), 1,
      anon_sym_import,
  [14905] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1490), 1,
      sym_identifier,
  [14912] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1492), 1,
      sym_identifier,
  [14919] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1494), 1,
      anon_sym_GT,
  [14926] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1496), 1,
      sym_identifier,
  [14933] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1498), 1,
      anon_sym_RBRACE,
  [14940] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1500), 1,
      sym_identifier,
  [14947] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1502), 1,
      sym_identifier,
  [14954] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1504), 1,
      anon_sym_RBRACE,
  [14961] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1506), 1,
      sym_identifier,
  [14968] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1508), 1,
      sym_identifier,
  [14975] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1510), 1,
      anon_sym_RBRACE,
  [14982] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1512), 1,
      sym_identifier,
  [14989] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1514), 1,
      sym_identifier,
  [14996] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1516), 1,
      sym_identifier,
  [15003] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1518), 1,
      sym_identifier,
  [15010] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1520), 1,
      sym_identifier,
  [15017] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1522), 1,
      sym_identifier,
  [15024] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1524), 1,
      anon_sym_EQ,
  [15031] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1526), 1,
      anon_sym_EQ,
  [15038] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1528), 1,
      sym_identifier,
  [15045] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1530), 1,
      ts_builtin_sym_end,
  [15052] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1532), 1,
      sym_identifier,
  [15059] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1534), 1,
      ts_builtin_sym_end,
  [15066] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1536), 1,
      anon_sym_RBRACE,
  [15073] = 2,
    ACTIONS(1538), 1,
      aux_sym_iri_token1,
    ACTIONS(1540), 1,
      sym_line_comment,
  [15080] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1542), 1,
      anon_sym_EQ,
  [15087] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
  [15094] = 2,
    ACTIONS(1540), 1,
      sym_line_comment,
    ACTIONS(1546), 1,
      aux_sym_iri_token1,
  [15101] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1548), 1,
      anon_sym_EQ,
  [15108] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1550), 1,
      anon_sym_COMMA,
  [15115] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1552), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 69,
  [SMALL_STATE(4)] = 137,
  [SMALL_STATE(5)] = 221,
  [SMALL_STATE(6)] = 289,
  [SMALL_STATE(7)] = 354,
  [SMALL_STATE(8)] = 419,
  [SMALL_STATE(9)] = 484,
  [SMALL_STATE(10)] = 549,
  [SMALL_STATE(11)] = 614,
  [SMALL_STATE(12)] = 679,
  [SMALL_STATE(13)] = 744,
  [SMALL_STATE(14)] = 825,
  [SMALL_STATE(15)] = 890,
  [SMALL_STATE(16)] = 968,
  [SMALL_STATE(17)] = 1046,
  [SMALL_STATE(18)] = 1124,
  [SMALL_STATE(19)] = 1199,
  [SMALL_STATE(20)] = 1271,
  [SMALL_STATE(21)] = 1392,
  [SMALL_STATE(22)] = 1513,
  [SMALL_STATE(23)] = 1634,
  [SMALL_STATE(24)] = 1703,
  [SMALL_STATE(25)] = 1824,
  [SMALL_STATE(26)] = 1945,
  [SMALL_STATE(27)] = 2066,
  [SMALL_STATE(28)] = 2187,
  [SMALL_STATE(29)] = 2308,
  [SMALL_STATE(30)] = 2429,
  [SMALL_STATE(31)] = 2550,
  [SMALL_STATE(32)] = 2671,
  [SMALL_STATE(33)] = 2725,
  [SMALL_STATE(34)] = 2779,
  [SMALL_STATE(35)] = 2833,
  [SMALL_STATE(36)] = 2887,
  [SMALL_STATE(37)] = 2941,
  [SMALL_STATE(38)] = 2994,
  [SMALL_STATE(39)] = 3047,
  [SMALL_STATE(40)] = 3100,
  [SMALL_STATE(41)] = 3153,
  [SMALL_STATE(42)] = 3206,
  [SMALL_STATE(43)] = 3259,
  [SMALL_STATE(44)] = 3312,
  [SMALL_STATE(45)] = 3365,
  [SMALL_STATE(46)] = 3411,
  [SMALL_STATE(47)] = 3456,
  [SMALL_STATE(48)] = 3537,
  [SMALL_STATE(49)] = 3618,
  [SMALL_STATE(50)] = 3699,
  [SMALL_STATE(51)] = 3780,
  [SMALL_STATE(52)] = 3861,
  [SMALL_STATE(53)] = 3903,
  [SMALL_STATE(54)] = 3945,
  [SMALL_STATE(55)] = 3987,
  [SMALL_STATE(56)] = 4067,
  [SMALL_STATE(57)] = 4109,
  [SMALL_STATE(58)] = 4189,
  [SMALL_STATE(59)] = 4231,
  [SMALL_STATE(60)] = 4273,
  [SMALL_STATE(61)] = 4315,
  [SMALL_STATE(62)] = 4357,
  [SMALL_STATE(63)] = 4406,
  [SMALL_STATE(64)] = 4481,
  [SMALL_STATE(65)] = 4556,
  [SMALL_STATE(66)] = 4631,
  [SMALL_STATE(67)] = 4709,
  [SMALL_STATE(68)] = 4755,
  [SMALL_STATE(69)] = 4833,
  [SMALL_STATE(70)] = 4911,
  [SMALL_STATE(71)] = 4989,
  [SMALL_STATE(72)] = 5035,
  [SMALL_STATE(73)] = 5081,
  [SMALL_STATE(74)] = 5159,
  [SMALL_STATE(75)] = 5237,
  [SMALL_STATE(76)] = 5315,
  [SMALL_STATE(77)] = 5393,
  [SMALL_STATE(78)] = 5439,
  [SMALL_STATE(79)] = 5517,
  [SMALL_STATE(80)] = 5589,
  [SMALL_STATE(81)] = 5627,
  [SMALL_STATE(82)] = 5699,
  [SMALL_STATE(83)] = 5771,
  [SMALL_STATE(84)] = 5838,
  [SMALL_STATE(85)] = 5905,
  [SMALL_STATE(86)] = 5941,
  [SMALL_STATE(87)] = 5977,
  [SMALL_STATE(88)] = 6013,
  [SMALL_STATE(89)] = 6049,
  [SMALL_STATE(90)] = 6085,
  [SMALL_STATE(91)] = 6121,
  [SMALL_STATE(92)] = 6157,
  [SMALL_STATE(93)] = 6193,
  [SMALL_STATE(94)] = 6229,
  [SMALL_STATE(95)] = 6265,
  [SMALL_STATE(96)] = 6301,
  [SMALL_STATE(97)] = 6338,
  [SMALL_STATE(98)] = 6400,
  [SMALL_STATE(99)] = 6462,
  [SMALL_STATE(100)] = 6524,
  [SMALL_STATE(101)] = 6586,
  [SMALL_STATE(102)] = 6648,
  [SMALL_STATE(103)] = 6707,
  [SMALL_STATE(104)] = 6742,
  [SMALL_STATE(105)] = 6777,
  [SMALL_STATE(106)] = 6809,
  [SMALL_STATE(107)] = 6841,
  [SMALL_STATE(108)] = 6897,
  [SMALL_STATE(109)] = 6937,
  [SMALL_STATE(110)] = 6969,
  [SMALL_STATE(111)] = 7001,
  [SMALL_STATE(112)] = 7033,
  [SMALL_STATE(113)] = 7065,
  [SMALL_STATE(114)] = 7096,
  [SMALL_STATE(115)] = 7133,
  [SMALL_STATE(116)] = 7170,
  [SMALL_STATE(117)] = 7201,
  [SMALL_STATE(118)] = 7232,
  [SMALL_STATE(119)] = 7269,
  [SMALL_STATE(120)] = 7302,
  [SMALL_STATE(121)] = 7355,
  [SMALL_STATE(122)] = 7392,
  [SMALL_STATE(123)] = 7445,
  [SMALL_STATE(124)] = 7498,
  [SMALL_STATE(125)] = 7551,
  [SMALL_STATE(126)] = 7581,
  [SMALL_STATE(127)] = 7619,
  [SMALL_STATE(128)] = 7649,
  [SMALL_STATE(129)] = 7679,
  [SMALL_STATE(130)] = 7709,
  [SMALL_STATE(131)] = 7739,
  [SMALL_STATE(132)] = 7769,
  [SMALL_STATE(133)] = 7799,
  [SMALL_STATE(134)] = 7829,
  [SMALL_STATE(135)] = 7858,
  [SMALL_STATE(136)] = 7887,
  [SMALL_STATE(137)] = 7920,
  [SMALL_STATE(138)] = 7959,
  [SMALL_STATE(139)] = 7988,
  [SMALL_STATE(140)] = 8027,
  [SMALL_STATE(141)] = 8066,
  [SMALL_STATE(142)] = 8095,
  [SMALL_STATE(143)] = 8124,
  [SMALL_STATE(144)] = 8153,
  [SMALL_STATE(145)] = 8185,
  [SMALL_STATE(146)] = 8213,
  [SMALL_STATE(147)] = 8241,
  [SMALL_STATE(148)] = 8273,
  [SMALL_STATE(149)] = 8301,
  [SMALL_STATE(150)] = 8337,
  [SMALL_STATE(151)] = 8369,
  [SMALL_STATE(152)] = 8397,
  [SMALL_STATE(153)] = 8425,
  [SMALL_STATE(154)] = 8453,
  [SMALL_STATE(155)] = 8481,
  [SMALL_STATE(156)] = 8518,
  [SMALL_STATE(157)] = 8545,
  [SMALL_STATE(158)] = 8588,
  [SMALL_STATE(159)] = 8625,
  [SMALL_STATE(160)] = 8654,
  [SMALL_STATE(161)] = 8679,
  [SMALL_STATE(162)] = 8716,
  [SMALL_STATE(163)] = 8743,
  [SMALL_STATE(164)] = 8772,
  [SMALL_STATE(165)] = 8809,
  [SMALL_STATE(166)] = 8838,
  [SMALL_STATE(167)] = 8867,
  [SMALL_STATE(168)] = 8894,
  [SMALL_STATE(169)] = 8921,
  [SMALL_STATE(170)] = 8958,
  [SMALL_STATE(171)] = 8985,
  [SMALL_STATE(172)] = 9011,
  [SMALL_STATE(173)] = 9037,
  [SMALL_STATE(174)] = 9063,
  [SMALL_STATE(175)] = 9089,
  [SMALL_STATE(176)] = 9117,
  [SMALL_STATE(177)] = 9143,
  [SMALL_STATE(178)] = 9175,
  [SMALL_STATE(179)] = 9209,
  [SMALL_STATE(180)] = 9235,
  [SMALL_STATE(181)] = 9261,
  [SMALL_STATE(182)] = 9290,
  [SMALL_STATE(183)] = 9315,
  [SMALL_STATE(184)] = 9340,
  [SMALL_STATE(185)] = 9365,
  [SMALL_STATE(186)] = 9390,
  [SMALL_STATE(187)] = 9415,
  [SMALL_STATE(188)] = 9442,
  [SMALL_STATE(189)] = 9465,
  [SMALL_STATE(190)] = 9488,
  [SMALL_STATE(191)] = 9511,
  [SMALL_STATE(192)] = 9536,
  [SMALL_STATE(193)] = 9561,
  [SMALL_STATE(194)] = 9584,
  [SMALL_STATE(195)] = 9611,
  [SMALL_STATE(196)] = 9634,
  [SMALL_STATE(197)] = 9659,
  [SMALL_STATE(198)] = 9684,
  [SMALL_STATE(199)] = 9723,
  [SMALL_STATE(200)] = 9746,
  [SMALL_STATE(201)] = 9774,
  [SMALL_STATE(202)] = 9812,
  [SMALL_STATE(203)] = 9835,
  [SMALL_STATE(204)] = 9864,
  [SMALL_STATE(205)] = 9889,
  [SMALL_STATE(206)] = 9910,
  [SMALL_STATE(207)] = 9933,
  [SMALL_STATE(208)] = 9956,
  [SMALL_STATE(209)] = 9977,
  [SMALL_STATE(210)] = 10006,
  [SMALL_STATE(211)] = 10027,
  [SMALL_STATE(212)] = 10048,
  [SMALL_STATE(213)] = 10082,
  [SMALL_STATE(214)] = 10104,
  [SMALL_STATE(215)] = 10130,
  [SMALL_STATE(216)] = 10152,
  [SMALL_STATE(217)] = 10186,
  [SMALL_STATE(218)] = 10209,
  [SMALL_STATE(219)] = 10232,
  [SMALL_STATE(220)] = 10255,
  [SMALL_STATE(221)] = 10290,
  [SMALL_STATE(222)] = 10313,
  [SMALL_STATE(223)] = 10348,
  [SMALL_STATE(224)] = 10371,
  [SMALL_STATE(225)] = 10394,
  [SMALL_STATE(226)] = 10417,
  [SMALL_STATE(227)] = 10440,
  [SMALL_STATE(228)] = 10463,
  [SMALL_STATE(229)] = 10481,
  [SMALL_STATE(230)] = 10515,
  [SMALL_STATE(231)] = 10533,
  [SMALL_STATE(232)] = 10551,
  [SMALL_STATE(233)] = 10569,
  [SMALL_STATE(234)] = 10587,
  [SMALL_STATE(235)] = 10605,
  [SMALL_STATE(236)] = 10623,
  [SMALL_STATE(237)] = 10641,
  [SMALL_STATE(238)] = 10675,
  [SMALL_STATE(239)] = 10693,
  [SMALL_STATE(240)] = 10711,
  [SMALL_STATE(241)] = 10729,
  [SMALL_STATE(242)] = 10747,
  [SMALL_STATE(243)] = 10765,
  [SMALL_STATE(244)] = 10782,
  [SMALL_STATE(245)] = 10799,
  [SMALL_STATE(246)] = 10816,
  [SMALL_STATE(247)] = 10833,
  [SMALL_STATE(248)] = 10850,
  [SMALL_STATE(249)] = 10867,
  [SMALL_STATE(250)] = 10884,
  [SMALL_STATE(251)] = 10901,
  [SMALL_STATE(252)] = 10918,
  [SMALL_STATE(253)] = 10935,
  [SMALL_STATE(254)] = 10952,
  [SMALL_STATE(255)] = 10969,
  [SMALL_STATE(256)] = 10986,
  [SMALL_STATE(257)] = 11003,
  [SMALL_STATE(258)] = 11020,
  [SMALL_STATE(259)] = 11037,
  [SMALL_STATE(260)] = 11054,
  [SMALL_STATE(261)] = 11071,
  [SMALL_STATE(262)] = 11088,
  [SMALL_STATE(263)] = 11105,
  [SMALL_STATE(264)] = 11122,
  [SMALL_STATE(265)] = 11139,
  [SMALL_STATE(266)] = 11156,
  [SMALL_STATE(267)] = 11173,
  [SMALL_STATE(268)] = 11190,
  [SMALL_STATE(269)] = 11207,
  [SMALL_STATE(270)] = 11224,
  [SMALL_STATE(271)] = 11257,
  [SMALL_STATE(272)] = 11274,
  [SMALL_STATE(273)] = 11291,
  [SMALL_STATE(274)] = 11308,
  [SMALL_STATE(275)] = 11325,
  [SMALL_STATE(276)] = 11342,
  [SMALL_STATE(277)] = 11359,
  [SMALL_STATE(278)] = 11376,
  [SMALL_STATE(279)] = 11393,
  [SMALL_STATE(280)] = 11410,
  [SMALL_STATE(281)] = 11427,
  [SMALL_STATE(282)] = 11444,
  [SMALL_STATE(283)] = 11477,
  [SMALL_STATE(284)] = 11494,
  [SMALL_STATE(285)] = 11511,
  [SMALL_STATE(286)] = 11528,
  [SMALL_STATE(287)] = 11545,
  [SMALL_STATE(288)] = 11562,
  [SMALL_STATE(289)] = 11590,
  [SMALL_STATE(290)] = 11618,
  [SMALL_STATE(291)] = 11646,
  [SMALL_STATE(292)] = 11674,
  [SMALL_STATE(293)] = 11702,
  [SMALL_STATE(294)] = 11730,
  [SMALL_STATE(295)] = 11758,
  [SMALL_STATE(296)] = 11786,
  [SMALL_STATE(297)] = 11813,
  [SMALL_STATE(298)] = 11838,
  [SMALL_STATE(299)] = 11865,
  [SMALL_STATE(300)] = 11892,
  [SMALL_STATE(301)] = 11917,
  [SMALL_STATE(302)] = 11941,
  [SMALL_STATE(303)] = 11965,
  [SMALL_STATE(304)] = 11989,
  [SMALL_STATE(305)] = 12013,
  [SMALL_STATE(306)] = 12037,
  [SMALL_STATE(307)] = 12061,
  [SMALL_STATE(308)] = 12082,
  [SMALL_STATE(309)] = 12101,
  [SMALL_STATE(310)] = 12122,
  [SMALL_STATE(311)] = 12141,
  [SMALL_STATE(312)] = 12160,
  [SMALL_STATE(313)] = 12175,
  [SMALL_STATE(314)] = 12196,
  [SMALL_STATE(315)] = 12215,
  [SMALL_STATE(316)] = 12234,
  [SMALL_STATE(317)] = 12255,
  [SMALL_STATE(318)] = 12272,
  [SMALL_STATE(319)] = 12293,
  [SMALL_STATE(320)] = 12308,
  [SMALL_STATE(321)] = 12327,
  [SMALL_STATE(322)] = 12348,
  [SMALL_STATE(323)] = 12369,
  [SMALL_STATE(324)] = 12388,
  [SMALL_STATE(325)] = 12409,
  [SMALL_STATE(326)] = 12428,
  [SMALL_STATE(327)] = 12453,
  [SMALL_STATE(328)] = 12474,
  [SMALL_STATE(329)] = 12495,
  [SMALL_STATE(330)] = 12516,
  [SMALL_STATE(331)] = 12537,
  [SMALL_STATE(332)] = 12552,
  [SMALL_STATE(333)] = 12573,
  [SMALL_STATE(334)] = 12592,
  [SMALL_STATE(335)] = 12613,
  [SMALL_STATE(336)] = 12634,
  [SMALL_STATE(337)] = 12655,
  [SMALL_STATE(338)] = 12673,
  [SMALL_STATE(339)] = 12695,
  [SMALL_STATE(340)] = 12717,
  [SMALL_STATE(341)] = 12735,
  [SMALL_STATE(342)] = 12751,
  [SMALL_STATE(343)] = 12773,
  [SMALL_STATE(344)] = 12791,
  [SMALL_STATE(345)] = 12811,
  [SMALL_STATE(346)] = 12831,
  [SMALL_STATE(347)] = 12851,
  [SMALL_STATE(348)] = 12869,
  [SMALL_STATE(349)] = 12887,
  [SMALL_STATE(350)] = 12909,
  [SMALL_STATE(351)] = 12929,
  [SMALL_STATE(352)] = 12949,
  [SMALL_STATE(353)] = 12965,
  [SMALL_STATE(354)] = 12983,
  [SMALL_STATE(355)] = 13005,
  [SMALL_STATE(356)] = 13016,
  [SMALL_STATE(357)] = 13033,
  [SMALL_STATE(358)] = 13048,
  [SMALL_STATE(359)] = 13059,
  [SMALL_STATE(360)] = 13078,
  [SMALL_STATE(361)] = 13097,
  [SMALL_STATE(362)] = 13114,
  [SMALL_STATE(363)] = 13133,
  [SMALL_STATE(364)] = 13148,
  [SMALL_STATE(365)] = 13159,
  [SMALL_STATE(366)] = 13176,
  [SMALL_STATE(367)] = 13187,
  [SMALL_STATE(368)] = 13204,
  [SMALL_STATE(369)] = 13219,
  [SMALL_STATE(370)] = 13236,
  [SMALL_STATE(371)] = 13247,
  [SMALL_STATE(372)] = 13266,
  [SMALL_STATE(373)] = 13285,
  [SMALL_STATE(374)] = 13300,
  [SMALL_STATE(375)] = 13311,
  [SMALL_STATE(376)] = 13330,
  [SMALL_STATE(377)] = 13347,
  [SMALL_STATE(378)] = 13366,
  [SMALL_STATE(379)] = 13385,
  [SMALL_STATE(380)] = 13404,
  [SMALL_STATE(381)] = 13420,
  [SMALL_STATE(382)] = 13432,
  [SMALL_STATE(383)] = 13444,
  [SMALL_STATE(384)] = 13456,
  [SMALL_STATE(385)] = 13468,
  [SMALL_STATE(386)] = 13482,
  [SMALL_STATE(387)] = 13498,
  [SMALL_STATE(388)] = 13514,
  [SMALL_STATE(389)] = 13528,
  [SMALL_STATE(390)] = 13544,
  [SMALL_STATE(391)] = 13558,
  [SMALL_STATE(392)] = 13574,
  [SMALL_STATE(393)] = 13588,
  [SMALL_STATE(394)] = 13604,
  [SMALL_STATE(395)] = 13618,
  [SMALL_STATE(396)] = 13630,
  [SMALL_STATE(397)] = 13642,
  [SMALL_STATE(398)] = 13656,
  [SMALL_STATE(399)] = 13672,
  [SMALL_STATE(400)] = 13684,
  [SMALL_STATE(401)] = 13696,
  [SMALL_STATE(402)] = 13712,
  [SMALL_STATE(403)] = 13726,
  [SMALL_STATE(404)] = 13740,
  [SMALL_STATE(405)] = 13750,
  [SMALL_STATE(406)] = 13766,
  [SMALL_STATE(407)] = 13780,
  [SMALL_STATE(408)] = 13796,
  [SMALL_STATE(409)] = 13810,
  [SMALL_STATE(410)] = 13822,
  [SMALL_STATE(411)] = 13838,
  [SMALL_STATE(412)] = 13854,
  [SMALL_STATE(413)] = 13867,
  [SMALL_STATE(414)] = 13878,
  [SMALL_STATE(415)] = 13891,
  [SMALL_STATE(416)] = 13904,
  [SMALL_STATE(417)] = 13913,
  [SMALL_STATE(418)] = 13926,
  [SMALL_STATE(419)] = 13935,
  [SMALL_STATE(420)] = 13948,
  [SMALL_STATE(421)] = 13961,
  [SMALL_STATE(422)] = 13974,
  [SMALL_STATE(423)] = 13987,
  [SMALL_STATE(424)] = 14000,
  [SMALL_STATE(425)] = 14013,
  [SMALL_STATE(426)] = 14026,
  [SMALL_STATE(427)] = 14039,
  [SMALL_STATE(428)] = 14050,
  [SMALL_STATE(429)] = 14063,
  [SMALL_STATE(430)] = 14076,
  [SMALL_STATE(431)] = 14089,
  [SMALL_STATE(432)] = 14102,
  [SMALL_STATE(433)] = 14115,
  [SMALL_STATE(434)] = 14128,
  [SMALL_STATE(435)] = 14141,
  [SMALL_STATE(436)] = 14154,
  [SMALL_STATE(437)] = 14167,
  [SMALL_STATE(438)] = 14180,
  [SMALL_STATE(439)] = 14193,
  [SMALL_STATE(440)] = 14206,
  [SMALL_STATE(441)] = 14219,
  [SMALL_STATE(442)] = 14228,
  [SMALL_STATE(443)] = 14241,
  [SMALL_STATE(444)] = 14252,
  [SMALL_STATE(445)] = 14263,
  [SMALL_STATE(446)] = 14276,
  [SMALL_STATE(447)] = 14286,
  [SMALL_STATE(448)] = 14296,
  [SMALL_STATE(449)] = 14304,
  [SMALL_STATE(450)] = 14314,
  [SMALL_STATE(451)] = 14324,
  [SMALL_STATE(452)] = 14334,
  [SMALL_STATE(453)] = 14342,
  [SMALL_STATE(454)] = 14352,
  [SMALL_STATE(455)] = 14362,
  [SMALL_STATE(456)] = 14372,
  [SMALL_STATE(457)] = 14382,
  [SMALL_STATE(458)] = 14392,
  [SMALL_STATE(459)] = 14400,
  [SMALL_STATE(460)] = 14410,
  [SMALL_STATE(461)] = 14418,
  [SMALL_STATE(462)] = 14426,
  [SMALL_STATE(463)] = 14436,
  [SMALL_STATE(464)] = 14446,
  [SMALL_STATE(465)] = 14454,
  [SMALL_STATE(466)] = 14462,
  [SMALL_STATE(467)] = 14472,
  [SMALL_STATE(468)] = 14482,
  [SMALL_STATE(469)] = 14492,
  [SMALL_STATE(470)] = 14500,
  [SMALL_STATE(471)] = 14508,
  [SMALL_STATE(472)] = 14518,
  [SMALL_STATE(473)] = 14526,
  [SMALL_STATE(474)] = 14534,
  [SMALL_STATE(475)] = 14542,
  [SMALL_STATE(476)] = 14550,
  [SMALL_STATE(477)] = 14558,
  [SMALL_STATE(478)] = 14568,
  [SMALL_STATE(479)] = 14578,
  [SMALL_STATE(480)] = 14588,
  [SMALL_STATE(481)] = 14596,
  [SMALL_STATE(482)] = 14604,
  [SMALL_STATE(483)] = 14611,
  [SMALL_STATE(484)] = 14618,
  [SMALL_STATE(485)] = 14625,
  [SMALL_STATE(486)] = 14632,
  [SMALL_STATE(487)] = 14639,
  [SMALL_STATE(488)] = 14646,
  [SMALL_STATE(489)] = 14653,
  [SMALL_STATE(490)] = 14660,
  [SMALL_STATE(491)] = 14667,
  [SMALL_STATE(492)] = 14674,
  [SMALL_STATE(493)] = 14681,
  [SMALL_STATE(494)] = 14688,
  [SMALL_STATE(495)] = 14695,
  [SMALL_STATE(496)] = 14702,
  [SMALL_STATE(497)] = 14709,
  [SMALL_STATE(498)] = 14716,
  [SMALL_STATE(499)] = 14723,
  [SMALL_STATE(500)] = 14730,
  [SMALL_STATE(501)] = 14737,
  [SMALL_STATE(502)] = 14744,
  [SMALL_STATE(503)] = 14751,
  [SMALL_STATE(504)] = 14758,
  [SMALL_STATE(505)] = 14765,
  [SMALL_STATE(506)] = 14772,
  [SMALL_STATE(507)] = 14779,
  [SMALL_STATE(508)] = 14786,
  [SMALL_STATE(509)] = 14793,
  [SMALL_STATE(510)] = 14800,
  [SMALL_STATE(511)] = 14807,
  [SMALL_STATE(512)] = 14814,
  [SMALL_STATE(513)] = 14821,
  [SMALL_STATE(514)] = 14828,
  [SMALL_STATE(515)] = 14835,
  [SMALL_STATE(516)] = 14842,
  [SMALL_STATE(517)] = 14849,
  [SMALL_STATE(518)] = 14856,
  [SMALL_STATE(519)] = 14863,
  [SMALL_STATE(520)] = 14870,
  [SMALL_STATE(521)] = 14877,
  [SMALL_STATE(522)] = 14884,
  [SMALL_STATE(523)] = 14891,
  [SMALL_STATE(524)] = 14898,
  [SMALL_STATE(525)] = 14905,
  [SMALL_STATE(526)] = 14912,
  [SMALL_STATE(527)] = 14919,
  [SMALL_STATE(528)] = 14926,
  [SMALL_STATE(529)] = 14933,
  [SMALL_STATE(530)] = 14940,
  [SMALL_STATE(531)] = 14947,
  [SMALL_STATE(532)] = 14954,
  [SMALL_STATE(533)] = 14961,
  [SMALL_STATE(534)] = 14968,
  [SMALL_STATE(535)] = 14975,
  [SMALL_STATE(536)] = 14982,
  [SMALL_STATE(537)] = 14989,
  [SMALL_STATE(538)] = 14996,
  [SMALL_STATE(539)] = 15003,
  [SMALL_STATE(540)] = 15010,
  [SMALL_STATE(541)] = 15017,
  [SMALL_STATE(542)] = 15024,
  [SMALL_STATE(543)] = 15031,
  [SMALL_STATE(544)] = 15038,
  [SMALL_STATE(545)] = 15045,
  [SMALL_STATE(546)] = 15052,
  [SMALL_STATE(547)] = 15059,
  [SMALL_STATE(548)] = 15066,
  [SMALL_STATE(549)] = 15073,
  [SMALL_STATE(550)] = 15080,
  [SMALL_STATE(551)] = 15087,
  [SMALL_STATE(552)] = 15094,
  [SMALL_STATE(553)] = 15101,
  [SMALL_STATE(554)] = 15108,
  [SMALL_STATE(555)] = 15115,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [7] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iri, 3, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iri, 3, 0, 0),
  [11] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 16),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 16),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [27] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [29] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [33] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 32),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 32),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_value, 1, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_value, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 63),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 63),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [63] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 2, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 2, 0, 0),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 100),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 100),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 5, 0, 109),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 5, 0, 109),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_constructor, 4, 0, 88),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_constructor, 4, 0, 88),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 3, 0, 80),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 3, 0, 80),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 99),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 99),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 99),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 99),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 5, 0, 109),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 5, 0, 109),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 100),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 100),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 62),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 62),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 87),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 87),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 80),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 80),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 61),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 61),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(108),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(75),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(115),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(299),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(119),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(549),
  [213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(438),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(132),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(132),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(127),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(130),
  [228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 2, 0, 92), SHIFT_REPEAT(146),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_value, 3, 0, 66),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_value, 3, 0, 66),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 2, 0, 34),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 2, 0, 34),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 59),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 59),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 1, 0, 20),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 1, 0, 20),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 4, 0, 89),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 4, 0, 89),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 65),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 65),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 67),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 67),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 67), SHIFT_REPEAT(544),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_composition, 2, 0, 35),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_composition, 2, 0, 35),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term, 1, 0, 0),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(166),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(75),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(343),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(119),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(549),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(438),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(132),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(132),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(127),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(130),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 60), SHIFT_REPEAT(146),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 6),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 6),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 89),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 89),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder, 5, 0, 103),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_builder, 5, 0, 103),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 65),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 65),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__actual_arguments, 2, 0, 0),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__actual_arguments, 2, 0, 0),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__actual_arguments, 3, 0, 91),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__actual_arguments, 3, 0, 91),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 20),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 20),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 34),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 34),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 59),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 59),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_functional_term, 2, 0, 38),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_sentence, 2, 0, 37),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_functional_term, 2, 0, 38),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(166),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(119),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(549),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(438),
  [441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(132),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(132),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(127),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 60), SHIFT_REPEAT(130),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 67), SHIFT_REPEAT(537),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(540),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(539),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(538),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(536),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(534),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(455),
  [512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(531),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(530),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(526),
  [521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(525),
  [524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(440),
  [531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(541),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_type, 5, 0, 108),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_type, 5, 0, 108),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_sentence, 3, 0, 69),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_boolean_sentence, 3, 0, 68),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 36),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_boolean_sentence, 2, 0, 39),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__actual_arguments_repeat1, 1, 0, 71),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__actual_arguments_repeat1, 1, 0, 71),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 1, 0, 4),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inequation, 3, 0, 72),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 2, 0, 22),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 2, 0, 22),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equation, 3, 0, 70),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0),
  [606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(542),
  [609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(550),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_property, 4, 0, 21),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_property, 4, 0, 21),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 3, 0, 36),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 3, 0, 36),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3, 0, 1),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3, 0, 1),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 4, 0, 74),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 4, 0, 74),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 31),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 31),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 1, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 1, 0, 0),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0),
  [647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(340),
  [650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_reference, 1, 0, 0),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_reference, 1, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 3, 0, 41),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 3, 0, 41),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 31),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 31),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 3, 0, 17),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 3, 0, 17),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 1, 0, 4),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 1, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_sentence, 1, 0, 0),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__rename_import, 2, 0, 15),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_import, 2, 0, 15),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 2, 0, 9),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 2, 0, 9),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 3, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 10),
  [699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_sentence, 1, 0, 0),
  [701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 9),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 9),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 2, 0, 13),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 2, 0, 13),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 2, 0, 25),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 2, 0, 25),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 43),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 3, 0, 50),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 3, 0, 50),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 4, 0, 23),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 2, 0, 6),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 3, 0, 24),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 3, 0, 24),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 2, 0, 6),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 2, 0, 6),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 5, 0, 57),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 2, 0, 6),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 2, 0, 6),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 75),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 2, 0, 6),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 44),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 2, 0, 6),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_restriction_value, 1, 0, 0),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 3, 0, 106),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_value, 1, 0, 0),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 4, 0, 111),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 4, 0, 111),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 3, 0, 105),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 4, 0, 111),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 4, 0, 112),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatype_def_restriction, 3, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 5, 0, 118),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 3, 0, 106),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 3, 0, 105),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 3, 0, 105),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 4, 0, 0),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 3, 0, 1),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 53),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 3, 0, 1),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 47),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 5, 0, 78),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 5, 0, 78),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 78),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 47),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 1, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 77),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 3, 0, 1),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 78),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 47),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 3, 0, 1),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 45),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 3, 0, 1),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 76),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 3, 0, 47),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 78),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 2, 0, 0),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 3, 0, 1),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 78),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 3, 0, 47),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 3, 0, 1),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 4, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 3, 0, 1),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 4, 0, 84),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 3, 0, 47),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 78),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_def, 2, 0, 7),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 6, 0, 86),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 47),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 3, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 2, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 2, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 4, 0, 27),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 3, 0, 0),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 7, 0, 95),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 1, 0, 28),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_variable_restriction_repeat1, 2, 0, 0),
  [961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_variable_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 56),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1, 0, 4),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, 0, 25),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, 0, 25),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 4),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 4),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable_restriction, 2, 0, 0),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 1, 0, 4),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable_restriction, 3, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 1, 0, 4),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, 0, 50),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, 0, 50),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(326),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0),
  [1031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(397),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(430),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 4, 0, 107),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 4, 0, 107),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 58), SHIFT_REPEAT(311),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 58),
  [1056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 58), SHIFT_REPEAT(298),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 58), SHIFT_REPEAT(45),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 58),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0), SHIFT_REPEAT(368),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0),
  [1089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(533),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 117),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 6, 0, 110),
  [1108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 83), SHIFT_REPEAT(45),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 83),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0),
  [1115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 2, 0, 46),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 2, 0, 46),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 2, 0, 102),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 116),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_environment, 2, 0, 0),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 73),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 54),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 54), SHIFT_REPEAT(483),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 3, 0, 90),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 3, 0, 90),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_entity_identity, 2, 0, 47),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_identity, 2, 0, 47),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member, 1, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member, 1, 0, 0),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(393),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 104), SHIFT_REPEAT(406),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 104),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 4, 0, 97),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 4, 0, 97),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 1, 0, 96),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 1, 0, 96),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 3, 0, 81),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 3, 0, 81),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_ref, 2, 0, 51),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_ref, 2, 0, 51),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 3, 0, 113),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 3, 0, 113),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_ordering, 1, 0, 0),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 10),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 42),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 5, 0, 115),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 5, 0, 115),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 1, 0, 4),
  [1239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 58), SHIFT_REPEAT(314),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 58),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0),
  [1246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 1, 0, 30),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable, 3, 0, 93),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 3, 0, 85),
  [1261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 114), SHIFT_REPEAT(469),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 114),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_relative, 2, 0, 12),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_absolute, 2, 0, 11),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_absolute, 3, 0, 18),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 1, 0, 49),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 64),
  [1286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 64), SHIFT_REPEAT(461),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 19),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 19), SHIFT_REPEAT(503),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_relative, 1, 0, 5),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 55),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 1, 0, 30),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 4, 0, 101),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 4, 0, 101),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 1, 0, 2),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 61),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 1, 0, 0),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 2, 0, 48),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 2, 0, 48),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, 0, 13),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_path_root_only, 1, 0, 0),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 62),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 1, 0, 33),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 3, 0, 42),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_uniqueness, 1, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 1, 0, 96),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_def, 2, 0, 42),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 1, 0, 30),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 1, 0, 94),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 28),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 1, 0, 29),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_path_absolute_repeat1, 2, 0, 11),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 2, 0, 48),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 2, 0, 48),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 1, 0, 52),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 4, 0, 87),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_universal, 1, 0, 0),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 4, 0, 14),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 4, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 2, 0, 26),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 3, 0, 0),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder_body, 1, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 5, 0, 0),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 2, 0, 98),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_existential, 1, 0, 0),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 3, 0, 8),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3, 0, 0),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 4, 0, 82),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 2, 0, 0),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 3),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 2, 0, 79),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2, 0, 0),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_op_combiner, 1, 0, 0),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 1),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable_binding, 2, 0, 40),
  [1552] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_sdml(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
